# HypergeometricFunctions.jl

[![Build Status](https://github.com/JuliaMath/HypergeometricFunctions.jl/workflows/CI/badge.svg)](https://github.com/JuliaMath/HypergeometricFunctions.jl/actions?query=workflow%3ACI) [![codecov](https://codecov.io/gh/JuliaMath/HypergeometricFunctions.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaMath/HypergeometricFunctions.jl) [![](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaMath.github.io/HypergeometricFunctions.jl/stable) [![](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaMath.github.io/HypergeometricFunctions.jl/dev)

This package provides an implementation of the generalized hypergeometric function `pFq(α, β, z)`.

```julia
julia> using HypergeometricFunctions

julia> pFq((), (), 0.1) # ≡ exp(0.1)
1.1051709180756477

julia> pFq((0.5, ), (), 1.0+0.001im) # ≡ exp(-0.5*log1p(-1.0-0.001im))
22.360679774997894 + 22.36067977499789im

julia> pFq((), (1.5, ), -π^2/4) # A root of a spherical Bessel function
4.042865030283967e-17

julia> pFq((1/3, ), (2/3, ), -1000) # A confluent hypergeometric with large argument
0.050558053946448855

julia> pFq((1, 2+im), (3.5, ), exp(im*π/3)) # ₂F₁ at that special point in ℂ
0.6786952632946592 + 0.4523504929285015im

```

# References

[1] N. Michel and M. V. Stoitsov, [Fast computation of the Gauss hypergeometric function with all its parameters complex with application to the Pöschl–Teller–Ginocchio potential wave functions](https://doi.org/10.1016/j.cpc.2007.11.007), *Comp. Phys. Commun.*, **178**:535–551, 2008.

[2] J. W. Pearson, S. Olver and M. A. Porter, [Numerical methods for the computation of the confluent and Gauss hypergeometric functions](https://doi.org/10.1007/s11075-016-0173-0), *Numer. Algor.*, **74**:821–866, 2017.

[3] R. M. Slevinsky, [Fast and stable rational approximation of generalized hypergeometric functions](https://doi.org/10.1007/s11075-024-01808-w), *Numer. Algor.*, **98**:587–624, 2025.

using ComplexPhasePortrait, Documenter, HypergeometricFunctions, Images

DocMeta.setdocmeta!(HypergeometricFunctions, :DocTestSetup, :(using HypergeometricFunctions); recursive=true)

makedocs(
    modules = [HypergeometricFunctions],
    sitename = "HypergeometricFunctions.jl",
    authors = "Richard Mikael Slevinsky",
    strict = false
)

deploydocs(repo = "github.com/JuliaMath/HypergeometricFunctions.jl.git")

# The references to special cases are to NIST's DLMF.

"""
Compute Kummer's confluent hypergeometric function `₁F₁(a, b, z)`.
"""
function _₁F₁(a, b, z; kwds...)
    z = float(z)
    if isequal(a, b) # 13.6.1
        return exp(z)
    elseif -b ∈ ℕ
        if -a ∈ ℕ₀ && real(a) ≥ real(b)
            return _₁F₁maclaurin(a, b, z; kwds...)
        else
            return throw(DomainError(b, "M(a, b, z) = ₁F₁(a, b, z) is not defined for negative integer b unless a is a nonpositive integer and a ≥ b."))
        end
    elseif -a ∈ ℕ₀
        return _₁F₁maclaurin(a, b, z; kwds...)
    elseif isequal(a, 1)
        if isequal(b, 2) # 13.6.2
            return iszero(z) ? one(z) : expm1(z)/z
        end
    end
    return _₁F₁general(a, b, z; kwds...)
end

function _₁F₁general(a, b, z; kwds...)
    if real(z) > 0
        return _₁F₁maclaurin(a, b, z; kwds...)
    else
        return pFqweniger((a, ), (b, ), z; kwds...)
    end
end

"""
Compute Kummer's confluent hypergeometric function `M(a, b, z) = ₁F₁(a, b, z)`.
"""
const M = _₁F₁

"""
Compute Tricomi's confluent hypergeometric function `U(a, b, z) ∼ z⁻ᵃ ₂F₀((a, a-b+1), (), -z⁻¹)`.
"""
function U(a, b, z; kwds...)
    return z^-a*pFq((a, a-b+1), (), -inv(z); kwds...)
end

module HypergeometricFunctions

using LinearAlgebra, Gamma

export _₁F₁, _₂F₁, _₃F₂, pFq

const KMAX = 1_048_576

include("specialfunctions.jl")
include("gauss.jl")
include("confluent.jl")
include("generalized.jl")
include("drummond.jl")
include("weniger.jl")
include("conformal.jl")

end #module

@inline errcheck(x, y, tol) = isfinite(x) && isfinite(y) && (norm(x-y) > max(norm(x), norm(y))*tol)

kind2string(::Val{0}) = "₀"
kind2string(::Val{1}) = "₁"
kind2string(::Val{2}) = "₂"
kind2string(::Val{3}) = "₃"
kind2string(::Val{4}) = "₄"
kind2string(::Val{5}) = "₅"
kind2string(::Val{6}) = "₆"
kind2string(::Val{7}) = "₇"
kind2string(::Val{8}) = "₈"
kind2string(::Val{9}) = "₉"
kind2string(::Val{p}) where p = kind2string(Val(div(p, 10)))*kind2string(Val(rem(p, 10)))
pFq2string(::Val{p}, ::Val{q}) where {p, q} = kind2string(Val(p))*"F"*kind2string(Val(q))

# Same as in FastTransforms.jl
"""
Pochhammer symbol ``(x)_n = \\frac{\\Gamma(x+n)}{\\Gamma(x)}`` for the rising factorial.
"""
function pochhammer(x::T, n::Integer) where T
    S = typeof(zero(T)/one(T))
    ret = one(S)
    if n ≥ 0
        for i = 0:n-1
            ret *= x+i
        end
    else
        ret /= pochhammer(x+n, -n)
    end
    ret
end

pochhammer(x::T, n::Number) where T = isinteger(n) ? pochhammer(x, Int(n)) : ogamma(x)/ogamma(x+n)

function pochhammer(x::Number, n::UnitRange{T}) where T <: Real
    ret = Vector{promote_type(typeof(x),T)}(undef, length(n))
    ret[1] = pochhammer(x, first(n))
    for i = 2:length(n)
        ret[i] = (x+n[i]-1)*ret[i-1]
    end
    ret
end

ogamma(x::Number) = (isinteger(x) && x<0) ? zero(float(x)) : inv(gamma(x))

unsafe_gamma(z) = gamma(z)
unsafe_gamma(x::Real) = (x == -Inf || (isinteger(x) && x < 0)) ? oftype(float(x), NaN) : gamma(x)

"""
    @clenshaw(x, c...)

Evaluate the Chebyshev polynomial series ``\\displaystyle \\sum_{k=1}^N c[k] T_{k-1}(x)`` by the Clenshaw algorithm.

External links: [DLMF](https://dlmf.nist.gov/3.11#ii), [Wikipedia](https://en.wikipedia.org/wiki/Clenshaw_algorithm).

# Examples
```jldoctest
julia> HypergeometricFunctions.@clenshaw(1, 1, 2, 3)
6

julia> HypergeometricFunctions.@clenshaw(0.5, 1, 2, 3)
0.5
```
"""
macro clenshaw(x, c...)
    a, b = :(zero(t)), :(zero(t))
    as = []
    for k = length(c):-1:2
        ak = Symbol("a", k)
        push!(as, :($ak = $a))
        a = :(muladd(t, $a, $(esc(c[k]))-$b))
        b = :($ak)
    end
    ex = Expr(:block, as..., :(muladd($(esc(x)), $a, $(esc(c[1]))-$b)))
    Expr(:block, :(t = $(esc(2))*$(esc(x))), ex)
end


const ρ = 0.72
const ρϵ = 0.71

struct ℕ end

Base.in(n::Integer, ::Type{ℕ}) = n > 0
Base.in(n::Number, ::Type{ℕ}) = isinteger(n) && Int(real(n)) ∈ ℕ

struct ℕ₀ end

Base.in(n::Integer, ::Type{ℕ₀}) = n ≥ 0
Base.in(n::Number, ::Type{ℕ₀}) = isinteger(n) && Int(real(n)) ∈ ℕ₀

struct ℤ end

Base.in(n::Number, ::Type{ℤ}) = isinteger(n)

abeqcd(a, b, cd) = isequal(a, b) && isequal(b, cd)
abeqcd(a, b, c, d) = isequal(a, c) && isequal(b, d)

ispositivelybalanced(a, b, c) = real(c - a - b) > 0
isalmostpositivelybalanced(a, b, c) = real(c - a - b) ≥ 0

ispositivelybalanced(α::NTuple{p, Any}, β::NTuple{q, Any}) where {p, q} = real(sum(β)-sum(α)) > 0
isalmostpositivelybalanced(α::NTuple{p, Any}, β::NTuple{q, Any}) where {p, q} = real(sum(β)-sum(α)) ≥ 0

function isacommonparameter(α::NTuple{p, S}, β::NTuple{q, T}) where {p, q, S, T}
    for i in 1:p
        for j in 1:q
            if α[i] == β[j] return true end
        end
    end
    return false
end

function findacommonparameter(α::NTuple{p, S}, β::NTuple{q, T}) where {p, q, S, T}
    for i in 1:p
        for j in 1:q
            if α[i] == β[j] return (i, j) end
        end
    end
    return (p+1, q+1)
end

"""
Cancel a common parameter in `α` and `β`, since `(x)ₖ/(x)ₖ ≡ 1` for any shared `x`.
Cancelling them avoids loss of accuracy (or a `0/0`,
if `x` is a nonpositive integer) in the generic algorithms.
"""
function cancelacommonparameter(α::NTuple{p, S}, β::NTuple{q, T}) where {p, q, S, T}
    i, j = findacommonparameter(α, β)
    γ = ntuple(k -> k < i ? α[k] : α[k+1], Val(p-1))
    δ = ntuple(k -> k < j ? β[k] : β[k+1], Val(q-1))
    return γ, δ
end

function isterminating(α::NTuple{p, Any}) where p
    for i in 1:p
        if -α[i] ∈ ℕ₀ return true end
    end
    return false
end

function getterminatinglength(α::NTuple{p, Any}) where p
    kmax = KMAX
    for i in 1:p
        if -α[i] ∈ ℕ₀ kmax = min(kmax, Int(-α[i])) end
    end
    return kmax
end

absarg(z) = abs(angle(z))

sqrtatanhsqrt(x) = x == 0 ? one(x) : (s = sqrt(-x); atan(s)/s)
sqrtasinsqrt(x) = x == 0 ? one(x) : (s = sqrt(x); asin(s)/s)
sinnasinsqrt(n, x) = x == 0 ? one(x) : (s = sqrt(x); sin(n*asin(s))/(n*s))
cosnasinsqrt(n, x) = cos(n*asin(sqrt(x)))
expnlog1pcoshatanhsqrt(n, x) = x == 0 ? one(x) : (s = sqrt(x); (exp(n*log1p(s))+exp(n*log1p(-s)))/2)
expnlog1psinhatanhsqrt(n, x) = x == 0 ? one(x) : (s = sqrt(x); (exp(n*log1p(s))-exp(n*log1p(-s)))/(2n*s))

sqrtatanhsqrt(x::Real) = x == 0 ? one(x) : x > 0 ? (s = sqrt(x); atanh(s)/s) : (s = sqrt(-x); atan(s)/s)
sqrtasinsqrt(x::Real) = x == 0 ? one(x) : x > 0 ? (s = sqrt(x); asin(s)/s) : (s = sqrt(-x); asinh(s)/s)
sinnasinsqrt(n, x::Real) = x == 0 ? one(x) : x > 0 ? (s = sqrt(x); sin(n*asin(s))/(n*s)) : (s = sqrt(-x); sinh(n*asinh(s))/(n*s))
cosnasinsqrt(n, x::Real) = x > 0 ? cos(n*asin(sqrt(x))) : cosh(n*asinh(sqrt(-x)))
expnlog1pcoshatanhsqrt(n, x::Real) = x == 0 ? one(x) : x > 0 ? exp(n/2*log1p(-x))*cosh(n*atanh(sqrt(x))) : exp(n/2*log1p(-x))*cos(n*atan(sqrt(-x)))
expnlog1psinhatanhsqrt(n, x::Real) = x == 0 ? one(x) : x > 0 ? (s = sqrt(x); exp(n/2*log1p(-x))*sinh(n*atanh(s))/(n*s)) : (s = sqrt(-x); exp(n/2*log1p(-x))*sin(n*atan(s))/(n*s))

expm1nlog1p(n, x) = x == 0 ? one(x) : expm1(n*log1p(x))/(n*x)

log1pover(x) = iszero(x) ? one(x) : log1p(x)/x
logandpoly(x) = iszero(x) ? one(x) : 6*(-2x+(x-2)*log1p(-x))/x^3
function logandpoly(x::Union{Float64, ComplexF64})
    if abs(x) > 0.2
        6*(-2x+(x-2)*log1p(-x))/x^3
    else
        logandpolyseries(x)
    end
end

logandpolyseries(x::Union{Float64, ComplexF64}) = @evalpoly(x, 1.0, 1.0, 0.9, 0.8, 0.7142857142857143, 0.6428571428571429, 0.5833333333333334, 0.5333333333333333, 0.4909090909090909, 0.45454545454545453, 0.4230769230769231, 0.3956043956043956, 0.37142857142857144, 0.35, 0.33088235294117646, 0.3137254901960784, 0.2982456140350877, 0.28421052631578947, 0.2714285714285714, 0.2597402597402597)

speciallog(x::Real) = iszero(x) ? one(x) : (x > 0 ? (s = sqrt(x); 3(atanh(s)-s)/s^3) : (s = sqrt(-x); 3(s-atan(s))/s^3))
speciallog(x) = iszero(x) ? one(x) : (s = sqrt(-x); 3(s-atan(s))/s^3)
function speciallog(x::Float64)
    if x > 0.2
        s = sqrt(x)
        3(atanh(s)-s)/s^3
    elseif x < -0.2
        s = sqrt(-x)
        3(s-atan(s))/s^3
    else
        speciallogseries(x)
    end
end
function speciallog(x::ComplexF64)
    if abs(x) > 0.2
        s = sqrt(-x)
        3(s-atan(s))/s^3
    else
        speciallogseries(x)
    end
end
# The Maclaurin series fails to be accurate to 1e-15 near x ≈ ±0.2. So we use a highly accurate Chebyshev expansion.
speciallogseries(x::Float64) = @clenshaw(5.0x, 1.0087391788544393911192, 1.220474262857857637288e-01, 8.7957928919918696061703e-03, 6.9050958578444820505037e-04, 5.7037120050065804396306e-05, 4.8731405131379353370205e-06, 4.2648797509486828820613e-07, 3.800372208946157617901e-08, 3.434168059359993493634e-09, 3.1381484326392473547608e-10, 2.8939845618385022798906e-11, 2.6892186934806386106143e-12, 2.5150879096374730760324e-13, 2.3652490233687788117887e-14, 2.2349973917002118259929e-15, 2.120769988408948118084e-16)
speciallogseries(x::ComplexF64) = @evalpoly(x, 1.0000000000000000000000, 5.9999999999999999999966e-01, 4.2857142857142857142869e-01, 3.3333333333333333333347e-01, 2.7272727272727272727292e-01, 2.3076923076923076923072e-01, 1.9999999999999999999996e-01, 1.7647058823529411764702e-01, 1.5789473684210526315786e-01, 1.4285714285714285714283e-01, 1.3043478260869565217384e-01, 1.2000000000000000000000e-01, 1.1111111111111111111109e-01, 1.0344827586206896551722e-01, 9.6774193548387096774217e-02, 9.0909090909090909090938e-02, 8.5714285714285714285696e-02, 8.1081081081081081081064e-02, 7.6923076923076923076907e-02, 7.3170731707317073170688e-02)


"""
    @lanczosratio(z, ϵ, c₀, c...)

Evaluate ``\\dfrac{\\displaystyle \\sum_{k=0}^{N-1} \\frac{c[k+1]}{(z+k)(z+k+\\epsilon)}}{\\displaystyle c_0 + \\sum_{k=0}^{N-1} \\frac{c[k+1]}{z+k}}``.

This ratio is used in the Lanczos approximation of ``\\log\\frac{\\Gamma(z+\\epsilon)}{\\Gamma(z)}`` in

> N. Michel and M. V. Stoitsov, [Fast computation of the Gauss hypergeometric function with all its parameters complex with application to the Pöschl–Teller–Ginocchio potential wave functions](https://doi.org/10.1016/j.cpc.2007.11.007), *Comp. Phys. Commun.*, **178**:535–551, 2008.
"""
macro lanczosratio(z, ϵ, c₀, c...)
    ex_num = :(zero(z))
    ex_den = esc(c₀)
    for k = 0:length(c)-1
        temp = :(inv(z+$k))
        ex_num = :(muladd($(esc(c[k+1])), $temp/(zpϵ+$k), $ex_num))
        ex_den = :(muladd($(esc(c[k+1])), $temp, $ex_den))
    end
    ex = :($ex_num/$ex_den)
    Expr(:block, :(z = $(esc(z))), :(zpϵ = $(esc(z))+$(esc(ϵ))), ex)
end

lanczosratio(z::Union{Float64, ComplexF64}, ϵ::Union{Float64, ComplexF64}) = @lanczosratio(z, ϵ, 0.99999999999999709182, 57.156235665862923517, -59.597960355475491248, 14.136097974741747174, -0.49191381609762019978, 0.33994649984811888699E-4, 0.46523628927048575665E-4, -0.98374475304879564677E-4, 0.15808870322491248884E-3, -0.21026444172410488319E-3, 0.21743961811521264320E-3, -0.16431810653676389022E-3, 0.84418223983852743293E-4, -0.26190838401581408670E-4, 0.36899182659531622704E-5)

function lanczosapprox(z::Union{Float64, ComplexF64}, ϵ::Union{Float64, ComplexF64})
    zm0p5 = z-0.5
    zpgm0p5 = zm0p5+4.7421875
    return zm0p5*log1p(ϵ/zpgm0p5) + ϵ*log(zpgm0p5+ϵ) - ϵ + log1p(-ϵ*lanczosratio(z, ϵ))
end

function H(z::Union{Float64, ComplexF64}, ϵ::Union{Float64, ComplexF64})
    zm0p5 = z-0.5
    zpgm0p5 = zm0p5+4.7421875
    if real(z) ≥ 1/2
        if z == z+ϵ # ϵ is numerical 0
            zm0p5/zpgm0p5 + log(zpgm0p5) - 1 - lanczosratio(z, ϵ)
        else
            expm1( zm0p5*log1p(ϵ/zpgm0p5) + ϵ*log(zpgm0p5+ϵ) - ϵ + log1p(-ϵ*lanczosratio(z, ϵ)) )/ϵ
        end
    else
        tpz = sinpi(z)/cospi(z)
        if z == z+ϵ # ϵ is numerical 0
            H(1-z, ϵ) - π/tpz
        else
            temp = (cospi(ϵ) + sinpi(ϵ)/tpz)*H(1-z, -ϵ) + .5ϵ*(π*sinc(.5ϵ))^2 - π*sinc(ϵ)/tpz
            temp/(1-ϵ*temp)
        end
    end
end

"""
Compute the function ``\\dfrac{\\frac{1}{\\Gamma(z)}-\\frac{1}{\\Gamma(z+\\epsilon)}}{\\epsilon}`` by the method dscribed in

> N. Michel and M. V. Stoitsov, [Fast computation of the Gauss hypergeometric function with all its parameters complex with application to the Pöschl–Teller–Ginocchio potential wave functions](https://doi.org/10.1016/j.cpc.2007.11.007), *Comp. Phys. Commun.*, **178**:535–551, 2008.
"""
function G(z::Union{Float64, ComplexF64}, ϵ::Union{Float64, ComplexF64})
    n, zpϵ = round(Int, real(z)), z+ϵ
    if abs(ϵ) > 0.1
        (inv(unsafe_gamma(z))-inv(unsafe_gamma(zpϵ)))/ϵ
    elseif z ≠ zpϵ
        m = round(Int, real(zpϵ))
        if z == n && n ≤ 0
            -inv(ϵ*unsafe_gamma(zpϵ))
        elseif zpϵ == m && m ≤ 0
            inv(ϵ*unsafe_gamma(z))
        elseif abs(z+abs(n)) < abs(zpϵ+abs(m))
            H(z, ϵ)/unsafe_gamma(zpϵ)
        else
            H(zpϵ, -ϵ)/unsafe_gamma(z)
        end
    else # ϵ is numerical 0
        if z == n && n ≤ 0
            (-1)^(n+1)*unsafe_gamma(1-n)
        else
            digamma(z)/unsafe_gamma(z)
        end
    end
end

G(z::T, ϵ::T) where {T<:Number} = ϵ == 0 ? digamma(z)/unsafe_gamma(z) : (inv(unsafe_gamma(z))-inv(unsafe_gamma(z+ϵ)))/ϵ
G(z::Number, ϵ::Number) = G(promote(z, ϵ)...)

"""
Compute the function ``\\dfrac{(z+\\epsilon)_m-(z)_m}{\\epsilon}`` by the method dscribed in

> N. Michel and M. V. Stoitsov, [Fast computation of the Gauss hypergeometric function with all its parameters complex with application to the Pöschl–Teller–Ginocchio potential wave functions](https://doi.org/10.1016/j.cpc.2007.11.007), *Comp. Phys. Commun.*, **178**:535–551, 2008.
"""
function P(z::Number, ϵ::Number, m::Int)
    n₀ = -round(Int, real(z))
    if ϵ == 0
        if 0 ≤ n₀ < m
            ret1, ret2, n = one(z), zero(z), 0
            while n < m
                n == n₀ && (n+=1; continue)
                ret1 *= z+n
                ret2 += inv(z+n)
                n += 1
            end
            ret1 + pochhammer(z, m)*ret2
        else
            ret = zero(z)
            for n=0:m-1
                ret += inv(z+n)
            end
            pochhammer(z, m)*ret
        end
    else
        if 0 ≤ n₀ < m
            zpϵ, ret1, ret2, n = z+ϵ, one(z), zero(z), 0
            while n < m
                n == n₀ && (n+=1; continue)
                ret1 *= zpϵ+n
                ret2 += log1p(ϵ/(z+n))
                n += 1
            end
            ret1 + pochhammer(z, m)*expm1(ret2)/ϵ
        else
            ret = zero(z)
            for n=0:m-1
                ret += log1p(ϵ/(z+n))
            end
            pochhammer(z, m)*expm1(ret)/ϵ
        end
    end
end

E(z::Number, ϵ::Number) = iszero(ϵ) ? z : expm1(ϵ*z)/ϵ

G(z::AbstractVector{BigFloat}, ϵ::BigFloat) = BigFloat[G(zi, ϵ) for zi in z]

# Transformation formula w = 1-z

function reconeα₀(a, b, c, m::Int, ϵ)
    _a, _b, _c, _ϵ = promote(a, b, c, ϵ)
    return _reconeα₀(_a, _b, _c, m, _ϵ)
end
function _reconeα₀(a::T, b::T, c::T, m::Int, ϵ::T) where {T}
    if ϵ == 0
        return (-1)^m*gamma(real(T)(m))*gamma(c)/(gamma(a+m)*gamma(b+m))
    else
        return gamma(c)/(ϵ*gamma(1-m-ϵ)*gamma(a+m+ϵ)*gamma(b+m+ϵ))
    end
end
function reconeβ₀(a, b, c, w, m::Int, ϵ)
    _a, _b, _c, _, _ϵ = promote(a, b, c, real(w), ϵ)
    _w, _ = promote(w, zero(_a))
    return _reconeβ₀(_a, _b, _c, _w, m, _ϵ)
end
function _reconeβ₀(a::T, b::T, c::T, w::Number, m::Int, ϵ::T) where {T}
    if abs(ϵ) > 0.1
        return ( pochhammer(a, m)*pochhammer(b, m)/(gamma(1-ϵ)*gamma(a+m+ϵ)*gamma(b+m+ϵ)*gamma(real(T)(m)+1)) - w^ϵ/(gamma(a)*gamma(b)*gamma(m+1+ϵ)) )*gamma(c)*w^m/ϵ
    else
        return ( (G(1, -ϵ)/gamma(real(T)(m)+1)+G(m+1, ϵ))/(gamma(a+m+ϵ)*gamma(b+m+ϵ)) - (G(a+m, ϵ)/gamma(b+m+ϵ)+G(float(b)+m, ϵ)/gamma(a+m))/gamma(m+1+ϵ) - E(log(w), ϵ)/(gamma(a+m)*gamma(b+m)*gamma(m+1+ϵ)) )*gamma(c)*pochhammer(a, m)*pochhammer(b, m)*w^m
    end
end
function reconeγ₀(a, b, c, w, m::Int, ϵ)
    _a, _b, _c, _, _ϵ = promote(a, b, c, real(w), ϵ)
    _w, _ = promote(w, zero(_a))
    return _reconeγ₀(_a, _b, _c, _w, m, _ϵ)
end
_reconeγ₀(a::T, b::T, c::T, w::Number, m::Int, ϵ::T) where {T} = gamma(c)*pochhammer(a, m)*pochhammer(b, m)*w^m/(gamma(a+m+ϵ)*gamma(b+m+ϵ)*gamma(real(T)(m)+1)*gamma(1-ϵ))

function Aone(a, b, c, w, m::Int, ϵ)
    αₙ = reconeα₀(a, b, c, m, ϵ)*one(w)
    ret = m ≤ 0 ? zero(w) : αₙ
    for n = 0:m-2
        αₙ *= (a+n)*(b+n)/((n+1)*(1-m-ϵ+n))*w
        ret += αₙ
    end
    ret
end

function Bone(a, b, c, w, m::Int, ϵ)
    T = promote_type(typeof(a), typeof(b), typeof(c), typeof(w), typeof(m), typeof(ϵ))
    βₙ, γₙ = reconeβ₀(a, b, c, w, m, ϵ)*one(w), reconeγ₀(a, b, c, w, m, ϵ)*w
    ret, n = βₙ, 0
    while abs(βₙ) > 8abs(ret)*eps(real(T)) || n ≤ 0
        βₙ = (a+m+n+ϵ)*(b+m+n+ϵ)/((m+n+1+ϵ)*(n+1))*w*βₙ + ( (a+m+n)*(b+m+n)/(m+n+1) - (a+m+n) - (b+m+n) - ϵ + (a+m+n+ϵ)*(b+m+n+ϵ)/(n+1) )*γₙ/((m+n+1+ϵ)*(n+1-ϵ))
        ret += βₙ
        γₙ *= (a+m+n)*(b+m+n)/((m+n+1)*(n+1-ϵ))*w
        n += 1
    end
    ret
end

function _₂F₁one(a, b, c, z)
    m = round(Int, real(c-(a+b)))
    ϵ = c-(a+b)-m
    w = 1-z
    (-1)^m/sinc(ϵ)*(Aone(a, b, c, w, m, ϵ) + Bone(a, b, c, w, m, ϵ))
end

# Transformation formula w = 1/z

function recInfα₀(a, b, c, m::Int, ϵ)
    _a, _b, _c, _ϵ = promote(a, b, c, ϵ)
    return _recInfα₀(_a, _b, _c, m, _ϵ)
end
function _recInfα₀(a::T, b::T, c::T, m::Int, ϵ::T) where {T}
    if ϵ == 0
        return (-1)^m*gamma(real(T)(m))*gamma(c)/(gamma(a+m)*gamma(c-a))
    else
        return gamma(c)/(ϵ*gamma(1-m-ϵ)*gamma(a+m+ϵ)*gamma(c-a))
    end
end
function recInfβ₀(a, b, c, w, m::Int, ϵ)
    _a, _b, _c, _, _ϵ = promote(a, b, c, real(w), ϵ)
    _w, _ = promote(w, zero(_a))
    return _recInfβ₀(_a, _b, _c, _w, m, _ϵ)
end
function _recInfβ₀(a::T, b::T, c::T, w::Number, m::Int, ϵ::T) where {T}
    if abs(ϵ) > 0.1
        return ( pochhammer(a, m)*pochhammer(1-c+a, m)/(gamma(1-ϵ)*gamma(a+m+ϵ)*gamma(c-a)*gamma(real(T)(m)+1)) -
            (-w)^ϵ*pochhammer(1-c+a+ϵ, m)/(gamma(a)*gamma(c-a-ϵ)*gamma(m+1+ϵ)) )*gamma(c)*w^m/ϵ
    else
        return ( (pochhammer(1-c+a+ϵ, m)*G(1, -ϵ)-P(1-c+a, ϵ, m)/gamma(1-ϵ))/(gamma(c-a)*gamma(a+m+ϵ)*gamma(real(T)(m)+1)) +
            pochhammer(1-c+a+ϵ, m)*( (G(m+1, ϵ)/gamma(a+m+ϵ) - G(a+m, ϵ)/gamma(m+1+ϵ))/gamma(c-a) -
            (G(c-a, -ϵ) - E(-log(-w), -ϵ)/gamma(c-a-ϵ))/(gamma(m+1+ϵ)*gamma(a+m)) ) )*gamma(c)*pochhammer(a, m)*w^m
    end
end
function recInfγ₀(a, b, c, w, m::Int, ϵ)
    _a, _b, _c, _, _ϵ = promote(a, b, c, real(w), ϵ)
    _w, _ = promote(w, zero(_a))
    return _recInfγ₀(_a, _b, _c, _w, m, _ϵ)
end
_recInfγ₀(a::T, b::T, c::T, w::Number, m::Int, ϵ::T) where {T} = gamma(c)*pochhammer(a, m)*pochhammer(1-c+a, m)*w^m/(gamma(a+m+ϵ)*gamma(c-a)*gamma(real(T)(m)+1)*gamma(1-ϵ))

function AInf(a, b, c, w, m::Int, ϵ)
    αₙ = recInfα₀(a, b, c, m, ϵ)*one(w)
    ret = m ≤ 0 ? zero(w) : αₙ
    for n = 0:m-2
        αₙ *= (a+n)*(1-c+a+n)/((n+1)*(1-m-ϵ+n))*w
        ret += αₙ
    end
    ret
end

function BInf(a, b, c, w, m::Int, ϵ)
    T = promote_type(typeof(a), typeof(b), typeof(c), typeof(w), typeof(m), typeof(ϵ))
    βₙ, γₙ = recInfβ₀(a, b, c, w, m, ϵ)*one(w), recInfγ₀(a, b, c, w, m, ϵ)*w
    ret, n = βₙ, 0
    while abs(βₙ) > 8abs(ret)*eps(real(T)) || n ≤ 0
        βₙ = (a+m+n+ϵ)*(1-c+a+m+n+ϵ)/((m+n+1+ϵ)*(n+1))*w*βₙ + ( (a+m+n)*(1-c+a+m+n)/(m+n+1) - (a+m+n) - (1-c+a+m+n) - ϵ + (a+m+n+ϵ)*(1-c+a+m+n+ϵ)/(n+1) )*γₙ/((m+n+1+ϵ)*(n+1-ϵ))
        ret += βₙ
        γₙ *= (a+m+n)*(1-c+a+m+n)/((m+n+1)*(n+1-ϵ))*w
        n += 1
    end
    ret
end

function _₂F₁Inf(a, b, c, z)
    if real(b-a) < 0
        return _₂F₁Inf(b, a, c, z)
    end
    m = round(Int, real(b-a))
    ϵ = b-a-m
    w = inv(z)
    (-1)^m*(-w)^a/sinc(ϵ)*(AInf(a, b, c, w, m, ϵ) + BInf(a, b, c, w, m, ϵ))
end


function _₂F₁maclaurin(a::Number, b::Number, c::Number, z::Number)
    T = promote_type(typeof(a), typeof(b), typeof(c), typeof(z))
    S₀, S₁, j = one(T), one(T)+a*b*z/c, 1
    while errcheck(S₀, S₁, 8eps(real(T)))
        rⱼ = (a+j)*z/(j+1)*(b+j)/(c+j)
        S₀, S₁ = S₁, S₁+(S₁-S₀)*rⱼ
        j += 1
    end
    return S₁
end

function _₂F₁maclaurinalt(a::Number, b::Number, c::Number, z::Number)
    T = promote_type(typeof(a), typeof(b), typeof(c), typeof(z))
    C, S, j = one(T), one(T), 0
    while abs(C) > 8abs(S)*eps(real(T)) || j ≤ 1
        C *= (a+j)/(j+1)*(b+j)/(c+j)*z
        S += C
        j += 1
    end
    return S
end

function _₂F₁continuation(s::Number, t::Number, c::Number, z₀::Number, z::Number)
    T = promote_type(typeof(s), typeof(t), typeof(c), typeof(z₀), typeof(z))
    izz₀, d0, d1 = inv(z-z₀), one(T), s/(2s-t+one(T))*((s+1)*(1-2z₀)+(t+1)*z₀-c)
    S₀, S₁, izz₀j, j = one(T), one(T)+d1*izz₀, izz₀, 2
    while errcheck(S₀, S₁, 8eps(real(T))) || j ≤ 2
        d0, d1, izz₀j = d1, (j+s-one(T))/j/(j+2s-t)*(((j+s)*(1-2z₀)+(t+1)*z₀-c)*d1 + z₀*(1-z₀)*(j+s-2)*d0), izz₀j*izz₀
        S₀, S₁ = S₁, S₁+d1*izz₀j
        j += 1
    end
    return S₁
end

function _₂F₁continuationalt(a::Number, c::Number, z₀::Number, z::Number)
    T = promote_type(typeof(a), typeof(c), typeof(z₀), typeof(z))
    izz₀ = inv(z-z₀)
    e0, e1 = one(T), (a+one(T))*(one(T)-2z₀)+(2a+one(T))*z₀-c
    f0, f1 = zero(T), one(T)-2z₀
    cⱼ = log(z₀-z)+2digamma(one(real(T)))-digamma(a)-digamma(c-a)
    S₀ = cⱼ
    cⱼ += 2/one(T)-one(T)/a
    C = a*izz₀
    S₁, j = S₀+(e1*cⱼ-f1)*C, 2
    while errcheck(S₀, S₁, 8eps(real(T))) || j ≤ 2
        f0, f1 = f1, (((j+a)*(1-2z₀)+(2a+1)*z₀-c)*f1+z₀*(1-z₀)*(j-1)*f0+(1-2z₀)*e1+2z₀*(1-z₀)*e0)/j
        e0, e1 = e1, (((j+a)*(1-2z₀)+(2a+1)*z₀-c)*e1+z₀*(1-z₀)*(j-1)*e0)/j
        C *= (a+j-1)*izz₀/j
        cⱼ += 2/T(j)-one(T)/(a+j-one(T))
        S₀, S₁ = S₁, S₁+(e1*cⱼ-f1)*C
        j += 1
    end
    return S₁
end

function _₂F₁logsum(a::Number, b::Number, z::Number, w::Number, s::Int)
    T = promote_type(typeof(a), typeof(b), typeof(z), typeof(w))
    cⱼ = 2digamma(one(real(T)))-digamma(a)-digamma(b)+s*log1p(-z)
    C, S, j = one(T), cⱼ, 0
    while abs(C) > 8abs(S)*eps(real(T)) || j ≤ 1
        C *= (a+j)/(j+1)^2*(b+j)*w
        cⱼ += 2/(j+one(T))-one(T)/(a+j)-one(T)/(b+j)
        S += C*cⱼ
        j += 1
    end
    return S
end

function _₂F₁logsumalt(a::Number, b::Number, z::Number, w::Number)
    T = promote_type(typeof(a), typeof(b), typeof(z), typeof(w))
    d, cⱼ = one(T)-b, 2digamma(one(real(T)))-digamma(a)-digamma(b)-log(-w)
    C, S, j = one(T), cⱼ, 0
    while abs(C) > 8abs(S)*eps(real(T)) || j ≤ 1
        C *= (a+j)/(j+1)^2*(d+j)*w
        cⱼ += 2/(j+one(T))-one(T)/(a+j)+one(T)/(b-(j+one(T)))
        S += C*cⱼ
        j += 1
    end
    return S
end

function _₂F₁taylor(a::Number, b::Number, c::Number, z::Number)
    T = promote_type(typeof(a), typeof(b), typeof(c), typeof(z))
    z₀ = abs(z) < 1 ? ρϵ*sign(z) : sign(z)/ρϵ
    q₀, q₁ = _₂F₁(a, b, c, z₀), a*b/c*_₂F₁(a+1, b+1, c+1, z₀)
    S₀, zz₀ = q₀, z-z₀
    S₁, zz₀j, j = S₀+q₁*zz₀, zz₀, 0
    while errcheck(S₀, S₁, 8eps(real(T))) || j ≤ 1
        q₀, q₁ = q₁, ((j*(2z₀-one(T))-c+(a+b+one(T))*z₀)*q₁ + (a+j)*(b+j)/(j+one(T))*q₀)/(z₀*(one(T)-z₀)*(j+2))
        zz₀j *= zz₀
        S₀, S₁ = S₁, S₁+q₁*zz₀j
        j += 1
    end
    return S₁
end

function _₁F₁maclaurin(a::Number, b::Number, z::Number)
    T = promote_type(typeof(a), typeof(b), typeof(z))
    S₀, S₁, j = one(T), one(T)+a*z/b, 1
    while errcheck(S₀, S₁, 8eps(real(T)))
        rⱼ = (a+j)*z/((b+j)*(j+1))
        S₀, S₁ = S₁, S₁+(S₁-S₀)*rⱼ
        j += 1
    end
    return S₁
end

function pFqmaclaurin(α::NTuple{p, Any}, β::NTuple{q, Any}, z; kwds...) where {p, q}
    T1 = isempty(α) ? Any : mapreduce(typeof, promote_type, α)
    T2 = isempty(β) ? Any : mapreduce(typeof, promote_type, β)
    pFqmaclaurin(T1.(α), T2.(β), z; kwds...)
end

function pFqmaclaurin(a::NTuple{p, S}, b::NTuple{q, U}, z::V; kmax::Int = KMAX) where {p, q, S, U, V}
    T = promote_type(eltype(a), eltype(b), V)
    S₀, S₁, k = one(T), one(T)+prod(a)*z/prod(b), 1
    while k < kmax && errcheck(S₀, S₁, 8eps(real(T)))
        rₖ = z/(k+one(T))
        for i=1:p rₖ *= a[i]+k end
        for i=1:q rₖ /= b[i]+k end
        S₀, S₁ = S₁, S₁+(S₁-S₀)*rₖ
        k += 1
    end
    k < kmax || @warn "Maclaurin approximation to "*pFq2string(Val(p), Val(q))*" reached the maximum degree of "*string(kmax)*"."
    return S₁
end

function pFqmaclaurin(α::NTuple{p, Any}, β::NTuple{q, Any}, z, kmax; kwds...) where {p, q}
    T1 = isempty(α) ? Any : mapreduce(typeof, promote_type, α)
    T2 = isempty(β) ? Any : mapreduce(typeof, promote_type, β)
    pFqmaclaurin(T1.(α), T2.(β), z, kmax; kwds...)
end

function pFqmaclaurin(a::NTuple{p, S}, b::NTuple{q, U}, z::V, kmax) where {p, q, S, U, V}
    T = promote_type(eltype(a), eltype(b), V)
    S₀, S₁, k = one(T), one(T)+prod(a)*z/prod(b), 1
    for k in 1:kmax-1
        rₖ = z/(k+one(T))
        for i=1:p rₖ *= a[i]+k end
        for i=1:q rₖ /= b[i]+k end
        S₀, S₁ = S₁, S₁+(S₁-S₀)*rₖ
    end
    return S₁
end

"""
Compute the generalized hypergeometric function `pFq(α, β, z)` by continued fraction.
"""
function pFqcontinuedfraction(α::AbstractVector{S}, β::AbstractVector{U}, z::V) where {S, U, V}
    T = promote_type(S, U, V)
    numerator(i) = - z * prod(i .+ α) / prod(i .+ β) / (i + 1)
    denominator(i) = 1 - numerator(i)
    K = continuedfraction(denominator, numerator, 10eps(real(T))) - denominator(0)
    # iszero(K + 1) leads to Inf, when e.g. Float64s run out of digits
    return 1 + z * prod(α) / prod(β) / (1 + K)
end

function continuedfraction(v::V, u::U, rtol::T) where {V<:Function, U<:Function, T<:Number}
    n = 4
    a, b = continuedfraction(v, u, n, 2n)
    n *= 2
    while n <= 2^16
        isapprox(a, b, rtol=rtol) && return b
        n *= 2
        a = deepcopy(b)
        b = continuedfraction(v, u, n)
    end
    isapprox(a, b, rtol=rtol) && return b
    error("Convergence failure for continued fraction for hypergeometric function")
end

function continuedfraction(v::V, u::U, n::Int, m::Int) where {V<:Function, U<:Function}
    @assert m > n
    output_m = u(m) / v(m)
    for i ∈ reverse(n+1:m-1)
        output_m = u(i) / (v(i) + output_m)
    end
    ui, vi = u(n), v(n)
    output_m = ui / (vi + output_m)
    output_n = ui / vi
    for i ∈ reverse(1:n-1)
        ui, vi = u(i), v(i)
        output_m = ui / (vi + output_m)
        output_n = ui / (vi + output_n)
    end
    vi = v(0)
    return vi + output_n, vi + output_m
end

function continuedfraction(v::V, u::U, n::Int) where {V<:Function, U<:Function}
    output = u(n) / v(n)
    for i ∈ reverse(1:n-1)
        output = u(i) / (v(i) + output)
    end
    return v(0) + output
end

# The references to special cases are to Table of Integrals, Series, and Products, § 9.121, followed by NIST's DLMF.

"""
Compute the Gauss hypergeometric function `₂F₁(a, b, c, z)`.
"""
function _₂F₁(a, b, c, z; method::Symbol = :general, kwds...)
    z = float(z)
    if real(b) < real(a)
        return _₂F₁(b, a, c, z; method = method, kwds...) # ensure a ≤ b
    elseif isequal(a, c) # 1. 15.4.6
        return exp(-b*log1p(-z))
    elseif isequal(b, c) # 1. 15.4.6
        return exp(-a*log1p(-z))
    elseif isequal(c, 0.5)
        if isequal(a+b, 0) # 31. 15.4.11 & 15.4.12
            return cosnasinsqrt(2b, z)
        elseif isequal(a+b, 1) # 32. 15.4.13 & 15.4.14
            return cosnasinsqrt(1-2b, z)*exp(-log1p(-z)/2)
        elseif isequal(b-a, 0.5) # 15.4.7 & 15.4.8
            return expnlog1pcoshatanhsqrt(-2a, z)
        end
    elseif isequal(c, 1.5)
        if abeqcd(a, b, 0.5) # 13. 15.4.4 & 15.4.5
            return sqrtasinsqrt(z)
        elseif abeqcd(a, b, 1) # 14.
            return sqrtasinsqrt(z)*exp(-log1p(-z)/2)
        elseif abeqcd(a, b, 0.5, 1) # 15. 15.4.2 & 15.4.3
            return sqrtatanhsqrt(z)
        elseif isequal(a+b, 1) # 29. 15.4.15 & 15.4.16
            return sinnasinsqrt(1-2b, z)
        elseif isequal(a+b, 2) # 30.
            return sinnasinsqrt(2-2b, z)*exp(-log1p(-z)/2)
        elseif isequal(b-a, 0.5) # 4. 15.4.9 & 15.4.10
            return expnlog1psinhatanhsqrt(1-2a, z)
        end
    elseif isequal(c, 2)
        if abeqcd(a, b, 1) # 6. 15.4.1
            return log1pover(-z)
        elseif a ∈ ℤ && b == 1 # 5.
            return expm1nlog1p(1-a, -z)
        elseif a == 1 && b ∈ ℤ # 5.
            return expm1nlog1p(1-b, -z)
        end
    elseif isequal(c, 4)
        if abeqcd(a, b, 2)
            return logandpoly(z)
        end
    elseif isequal(c, 2.5) && abeqcd(a, b, 1, 1.5)
        return speciallog(z)
    end
    if method == :positive
        return _₂F₁positive(a, b, c, z; kwds...)
    #elseif method == :general2
    #    return _₂F₁general2(a, b, c, z; kwds...)
    else#if method == :general
        return _₂F₁general(a, b, c, z; kwds...) # catch-all
    end
end

"""
Compute the Gauss hypergeometric function `₂F₁(a, b, c, z)` with positive parameters a, b, and c and argument 0 ≤ z ≤ 1. Useful for statisticians.
"""
function _₂F₁positive(a, b, c, z; kwds...)
    @assert a > 0 && b > 0 && c > 0 && 0 ≤ z ≤ 1
    if z == 1
        return _₂F₁argument_unity(a, b, c, z; kwds...)
    else
        return _₂F₁maclaurin(a, b, c, z; kwds...)
    end
end

"""
Compute the Gauss hypergeometric function `₂F₁(a, b, c, z)` with general parameters a, b, and c.
This polyalgorithm is designed based on the paper

> N. Michel and M. V. Stoitsov, [Fast computation of the Gauss hypergeometric function with all its parameters complex with application to the Pöschl–Teller–Ginocchio potential wave functions](https://doi.org/10.1016/j.cpc.2007.11.007), *Comp. Phys. Commun.*, **178**:535–551, 2008.
"""
function _₂F₁general(a, b, c, z; kwds...)
    if z == 1
        return _₂F₁argument_unity(a, b, c, z; kwds...)
    elseif real(b) < real(a)
        return _₂F₁general(b, a, c, z; kwds...)
    elseif abs(z) ≤ ρ || -a ∈ ℕ₀ || -b ∈ ℕ₀
        return _₂F₁maclaurin(a, b, c, z; kwds...)
    elseif !isalmostwellpoised(a, b, c)
        return exp((c-a-b)*log1p(-z))*_₂F₁general(c-a, c-b, c, z; kwds...)
    elseif abs(z/(z-1)) ≤ ρ
        return exp(-a*log1p(-z))_₂F₁maclaurin(a, c-b, c, z/(z-1); kwds...)
    elseif abs(inv(z)) ≤ ρ
        return _₂F₁Inf(a, b, c, z; kwds...)
    elseif abs(1-inv(z)) ≤ ρ
        return exp(-a*log1p(-z))*_₂F₁Inf(a, c-b, c, z/(z-1); kwds...)
    elseif abs(1-z) ≤ ρ
        return _₂F₁one(a, b, c, z; kwds...)
    elseif abs(inv(1-z)) ≤ ρ
        return exp(-a*log1p(-z))*_₂F₁one(a, c-b, c, z/(z-1); kwds...)
    else
        return pFqweniger((a, b), (c, ), z; kwds...) # _₂F₁taylor(a, b, c, z; kwds...)
    end
end

"""
Compute the Gauss hypergeometric function `₂F₁(a, b, c, z)` with general parameters a, b, and c.
This polyalgorithm is designed based on the review

> J. W. Pearson, S. Olver and M. A. Porter, [Numerical methods for the computation of the confluent and Gauss hypergeometric functions](https://doi.org/10.1007/s11075-016-0173-0), *Numer. Algor.*, **74**:821–866, 2017.
"""
function _₂F₁general2(a, b, c, z; kwds...)
    T = promote_type(typeof(a), typeof(b), typeof(c), typeof(z))
    if z == 1
        return _₂F₁argument_unity(a, b, c, z; kwds...)
    elseif real(b) < real(a)
        return _₂F₁general2(b, a, c, z; kwds...)
    elseif abs(z) ≤ ρ || -a ∈ ℕ₀ || -b ∈ ℕ₀
        return _₂F₁maclaurin(a, b, c, z; kwds...)
    elseif !isalmostwellpoised(a, b, c)
        return exp((c-a-b)*log1p(-z))*_₂F₁general2(c-a, c-b, c, z; kwds...)
    elseif abs(z / (z - 1)) ≤ ρ && absarg(1 - z) < convert(real(T), π) # 15.8.1
        w = z/(z-1)
        return _₂F₁maclaurin(a, c-b, c, w; kwds...)*exp(-a*log1p(-z))
    elseif abs(inv(z)) ≤ ρ && absarg(-z) < convert(real(T), π)
        w = inv(z)
        if isapprox(a, b) # 15.8.8
            return gamma(c)/gamma(a)/gamma(c-a)*(-w)^a*_₂F₁logsumalt(a, c-a, z, w; kwds...)
        elseif a-b ∉ ℤ # 15.8.2
            return gamma(c)*((-w)^a*gamma(b-a)/gamma(b)/gamma(c-a)*_₂F₁maclaurin(a, a-c+1, a-b+1, w; kwds...)+(-w)^b*gamma(a-b)/gamma(a)/gamma(c-b)*_₂F₁maclaurin(b, b-c+1, b-a+1, w; kwds...))
        end # TODO: full 15.8.8
    elseif abs(inv(1-z)) ≤ ρ && absarg(-z) < convert(real(T), π)
        w = inv(1-z)
        if isapprox(a, b) # 15.8.9
            return gamma(c)*exp(-a*log1p(-z))/gamma(a)/gamma(c-b)*_₂F₁logsum(a, c-a, z, w, 1; kwds...)
        elseif a-b ∉ ℤ # 15.8.3
            return gamma(c)*(exp(-a*log1p(-z))*gamma(b-a)/gamma(b)/gamma(c-a)*_₂F₁maclaurin(a, c-b, a-b+1, w; kwds...)+exp(-b*log1p(-z))*gamma(a-b)/gamma(a)/gamma(c-b)*_₂F₁maclaurin(b, c-a, b-a+1, w; kwds...))
        end # TODO: full 15.8.9
    elseif abs(1-z) ≤ ρ && absarg(z) < convert(real(T), π) && absarg(1-z) < convert(real(T), π)
        w = 1-z
        if isapprox(c, a + b) # 15.8.10
            return gamma(c)/gamma(a)/gamma(b)*_₂F₁logsum(a, b, z, w, -1; kwds...)
        elseif c - a - b ∉ ℤ # 15.8.4
            return gamma(c)*(gamma(c-a-b)/gamma(c-a)/gamma(c-b)*_₂F₁maclaurin(a, b, a+b-c+1, w; kwds...)+exp((c-a-b)*log1p(-z))*gamma(a+b-c)/gamma(a)/gamma(b)*_₂F₁maclaurin(c-a, c-b, c-a-b+1, w; kwds...))
        end # TODO: full 15.8.10
    elseif abs(1-inv(z)) ≤ ρ && absarg(z) < convert(real(T), π) && absarg(1-z) < convert(real(T), π)
        w = 1-inv(z)
        if isapprox(c, a + b) # 15.8.11
            return gamma(c)*z^(-a)/gamma(a)*_₂F₁logsumalt(a, b, z, w; kwds...)
        elseif c - a - b ∉ ℤ # 15.8.5
            return gamma(c)*(z^(-a)*gamma(c-a-b)/gamma(c-a)/gamma(c-b)*_₂F₁maclaurin(a, a-c+1, a+b-c+1, w; kwds...)+z^(a-c)*(1-z)^(c-a-b)*gamma(a+b-c)/gamma(a)/gamma(b)*_₂F₁maclaurin(c-a, 1-a, c-a-b+1, w; kwds...))
        end # TODO: full 15.8.11
    elseif abs(z-0.5) > 0.5
        if isapprox(a, b) && !isapprox(c, a+0.5)
            return gamma(c)/gamma(a)/gamma(c-a)*(0.5-z)^(-a)*_₂F₁continuationalt(a, c, 0.5, z; kwds...)
        elseif a-b ∉ ℤ && !isapprox(2c, a+b+1)
            return gamma(c)*(gamma(b-a)/gamma(b)/gamma(c-a)*(0.5-z)^(-a)*_₂F₁continuation(a, a+b, c, 0.5, z; kwds...) + gamma(a-b)/gamma(a)/gamma(c-b)*(0.5-z)^(-b)*_₂F₁continuation(b, a+b, c, 0.5, z; kwds...))
        end
    end
    return pFqweniger((a, b), (c, ), z; kwds...) # _₂F₁taylor(a, b, c, z; kwds...)
end

# Special case of (-x)^a*_₂F₁ to handle LogNumber correctly in RiemannHilbert.jl
function mxa_₂F₁(a, b, c, z; kwds...)
    if isequal(c, 2)
        if abeqcd(a, b, 1) # 6. 15.4.1
            return log1p(-z)
        end
    elseif isequal(c, 4)
        if abeqcd(a, b, 2)
            return 6*(-2 + (1-2/z)*log1p(-z))
        end
    end
    return (-z)^a*_₂F₁(a, b, c, z; kwds...)
end

function _₂F₁argument_unity(a, b, c, z; kwds...)
    T = promote_type(typeof(a), typeof(b), typeof(c), typeof(z))
    a, b, c = T(a), T(b), T(c)
    if iswellpoised(a, b, c)
        return exp(loggamma(c)-loggamma(c-a)+loggamma(c-a-b)-loggamma(c-b))
    elseif isalmostwellpoised(a, b, c)
        if a + b == c
            f = loggamma(c)-loggamma(a)-loggamma(b)
            if isreal(f)
                return T(Inf)
            else
                return T(Inf)*sign(exp(f))
            end
        else
            return T(NaN)
        end
    else # !isalmostwellpoised(a, b, c)
        f = loggamma(c)-loggamma(a)+gamma(a+b-c)-loggamma(b)
        if isreal(f)
            return T(Inf)
        else
            return T(Inf)*sign(exp(f))
        end
    end
end

@doc raw"""
    pFqdrummond(α, β, z; kmax)
Compute the generalized hypergeometric function [`pFq`](@ref) by rational approximations of type (k, k) generated by Drummond's sequence transformation described in

> R. M. Slevinsky, [Fast and stable rational approximation of generalized hypergeometric functions](https://doi.org/10.1007/s11075-024-01808-w), *Numer. Algor.*, **98**:587–624, 2025.
"""
pFqdrummond

# ₀F₀(;z)
function pFqdrummond(::Tuple{}, ::Tuple{}, z::T; kmax::Int = KMAX) where T
    if norm(z) < eps(real(T))
        return one(T)
    end
    μlo = one(z)
    Tlo = one(z)
    k = 0
    if iszero(2-z)
        μhi = inv(2-z)
        Thi = Tlo + 2z*μhi
        k += 1
        μhi, μlo = inv(k+2-z + k*z*μhi), μhi
        Thi, Tlo = 6-z + Tlo, Thi
        k += 1
        μhi, μlo = inv(k+2-z + k*z*μhi), μhi
        Thi, Tlo = ((k+2-z)*Thi + k*z*2)*μhi, Thi
        k += 1
    else
        μhi = inv(2-z)
        Thi = Tlo + 2z*μhi
        k += 1
        if iszero(3-z + z*μhi)
            μhi, μlo = inv(3-z + z*μhi), μhi
            cst = (3-z)*Thi + z*(Tlo+z)*μlo
            Thi, Tlo = cst*μhi, Thi
            k += 1
            μhi, μlo = inv(k+2-z + k*z*μhi), μhi
            Thi, Tlo = (k+2-z)*cst/(k*z) + Tlo, Thi
            k += 1
            μhi, μlo = inv(k+2-z + k*z*μhi), μhi
            Thi, Tlo = Thi + (k*cst/T(k-1))*μhi, Thi
            k += 1
        else
            μhi, μlo = inv(3-z + z*μhi), μhi
            Thi, Tlo = ((3-z)*Thi + z*(Tlo+z)*μlo)*μhi, Thi
            k += 1
        end
    end
    while k < kmax && errcheck(Tlo, Thi, 8eps(real(T)))
        if iszero(k+2-z + k*z*μhi)
            μhi, μlo = inv(k+2-z + k*z*μhi), μhi
            cst = ((k+2-z)*Thi + k*z*Tlo*μlo)
            Thi, Tlo = cst*μhi, Thi
            k += 1
            μhi, μlo = inv(k+2-z + k*z*μhi), μhi
            Thi, Tlo = (k+2-z)*cst/(k*z) + Tlo, Thi
            k += 1
            μhi, μlo = inv(k+2-z + k*z*μhi), μhi
            Thi, Tlo = Thi + (k*cst/T(k-1))*μhi, Thi
            k += 1
        else
            μhi, μlo = inv(k+2-z + k*z*μhi), μhi
            Thi, Tlo = ((k+2-z)*Thi + k*z*Tlo*μlo)*μhi, Thi
            k += 1
        end
    end
    k < kmax || @warn "Rational approximation to "*pFq2string(Val(0), Val(0))*" reached the maximum type of ("*string(kmax, ", ", kmax)*")."
    return isfinite(Thi) ? Thi : Tlo
end

# ₁F₀(α;z)
function pFqdrummond(α::Tuple{T1}, ::Tuple{}, z::T2; kmax::Int = KMAX) where {T1, T2}
    α = α[1]
    T = promote_type(T1, T2)
    absα = abs(T(α))
    if norm(z) < eps(real(T)) || norm(α) < eps(absα)
        return one(T)
    end
    ζ = inv(z)
    Nlo = ζ/α
    Dlo = ζ/α
    Tlo = Nlo/Dlo
    Nhi = (2ζ - (α+1))*Nlo + 2ζ
    Dhi = (2ζ - (α+1))*Dlo
    Thi = Nhi/Dhi
    if norm(α+1) < eps(absα+1)
        return Thi
    end
    Nhi /= α+1
    Dhi /= α+1
    Nhi, Nlo = (3ζ-(α+3))*Nhi + (ζ-1)*Nlo + ζ, Nhi
    Dhi, Dlo = (3ζ-(α+3))*Dhi + (ζ-1)*Dlo, Dhi
    Thi, Tlo = Nhi/Dhi, Thi
    if norm(α+2) < eps(absα+2)
        return Thi
    end
    Nhi /= α+2
    Dhi /= α+2
    k = 2
    while k < kmax && errcheck(Tlo, Thi, 8eps(real(T)))
        Nhi, Nlo = ((k+2)*ζ-(α+2k+1))*Nhi + k*(ζ-1)*Nlo, Nhi
        Dhi, Dlo = ((k+2)*ζ-(α+2k+1))*Dhi + k*(ζ-1)*Dlo, Dhi
        Thi, Tlo = Nhi/Dhi, Thi
        if norm(α+k+1) < eps(absα+k+1)
            return Thi
        end
        Nhi /= α+k+1
        Dhi /= α+k+1
        k += 1
    end
    k < kmax || @warn "Rational approximation to "*pFq2string(Val(1), Val(0))*" reached the maximum type of ("*string(kmax, ", ", kmax)*")."
    return isfinite(Thi) ? Thi : Tlo
end

# ₀F₁(β;z)
function pFqdrummond(::Tuple{}, β::Tuple{T1}, z::T2; kmax::Int = KMAX) where {T1, T2}
    β = β[1]
    T = promote_type(T1, T2)
    if norm(z) < eps(real(T))
        return one(T)
    end
    ζ = inv(z)
    Nlo = β*ζ
    Dlo = β*ζ
    Tlo = Nlo/Dlo
    Nmid = ((β+1)*(2)*ζ - 1)*Nlo + (β+1)*(2)*ζ
    Dmid = ((β+1)*(2)*ζ - 1)*Dlo
    Tmid = Nmid/Dmid
    Nhi = ((β+2)*(3)*ζ - 1)*Nmid + (β+4)*ζ*Nlo + (β+4)*ζ
    Dhi = ((β+2)*(3)*ζ - 1)*Dmid + (β+4)*ζ*Dlo
    Thi = Nhi/Dhi
    k = 2
    Nhi, Nmid, Nlo = ((β+k+1)*(k+2)*ζ-1)*Nhi + k*(β+2k+2)*ζ*Nmid + k*(k-1)*ζ*Nlo + 2ζ, Nhi, Nmid
    Dhi, Dmid, Dlo = ((β+k+1)*(k+2)*ζ-1)*Dhi + k*(β+2k+2)*ζ*Dmid + k*(k-1)*ζ*Dlo, Dhi, Dmid
    Thi, Tmid, Tlo = Nhi/Dhi, Thi, Tmid
    k += 1
    while k < kmax && errcheck(Tmid, Thi, 8eps(real(T)))
        Nhi, Nmid, Nlo = ((β+k+1)*(k+2)*ζ-1)*Nhi + k*(β+2k+2)*ζ*Nmid + k*(k-1)*ζ*Nlo, Nhi, Nmid
        Dhi, Dmid, Dlo = ((β+k+1)*(k+2)*ζ-1)*Dhi + k*(β+2k+2)*ζ*Dmid + k*(k-1)*ζ*Dlo, Dhi, Dmid
        Thi, Tmid, Tlo = Nhi/Dhi, Thi, Tmid
        k += 1
    end
    k < kmax || @warn "Rational approximation to "*pFq2string(Val(0), Val(1))*" reached the maximum type of ("*string(kmax, ", ", kmax)*")."
    return isfinite(Thi) ? Thi : isfinite(Tmid) ? Tmid : Tlo
end

# ₂F₀(α,β;z)
function pFqdrummond(α::Tuple{T1, T1}, ::Tuple{}, z::T2; kmax::Int = KMAX) where {T1, T2}
    (α, β) = α
    T = promote_type(T1, T2)
    absα = abs(T(α))
    absβ = abs(T(β))
    if norm(z) < eps(real(T)) || norm(α*β) < eps(absα*absβ)
        return one(T)
    end
    μlo = T(α*β)
    Tlo = one(T)
    μmid = inv(2-(α+1)*(β+1)*z)
    Tmid = Tlo + 2z*μmid*μlo
    if norm((α+1)*(β+1)) < eps((absα+1)*(absβ+1))
        return Tmid
    end
    μmid *= (α+1)*(β+1)
    μhi = inv((3-((α+2)*(β+2)+(α+β+3))*z) + (1-(α+β+3)*z)*z*μmid)
    Thi = ((3-((α+2)*(β+2)+(α+β+3))*z)*Tmid + ((1-(α+β+3)*z)*Tlo + z*μlo)*z*μmid)*μhi
    if norm((α+2)*(β+2)) < eps((absα+2)*(absβ+2))
        return Thi
    end
    μhi *= (α+2)*(β+2)
    k = 2
    z2 = z*z
    while k < 3 || (k < kmax && errcheck(Tmid, Thi, 8eps(real(T))))
        μhi, μmid, μlo = inv((k+2)-((α+k+1)*(β+k+1)+k*(α+β+2k+1))*z + k*((1-(α+β+3k)*z) - (k-1)*z2*μmid)*z*μhi), μhi, μmid
        Thi, Tmid, Tlo = (((k+2)-((α+k+1)*(β+k+1)+k*(α+β+2k+1))*z)*Thi + k*((1-(α+β+3k)*z)*Tmid - (k-1)*z2*Tlo*μlo)*z*μmid)*μhi, Thi, Tmid
        if norm((α+k+1)*(β+k+1)) < eps((absα+k+1)*(absβ+k+1))
            return Thi
        end
        μhi *= (α+k+1)*(β+k+1)
        k += 1
    end
    k < kmax || @warn "Rational approximation to "*pFq2string(Val(2), Val(0))*" reached the maximum type of ("*string(kmax, ", ", kmax)*")."
    return isfinite(Thi) ? Thi : isfinite(Tmid) ? Tmid : Tlo
end

# ₁F₁(α,β;z)
function pFqdrummond(α::Tuple{T1}, β::Tuple{T2}, z::T3; kmax::Int = KMAX) where {T1, T2, T3}
    α = α[1]
    β = β[1]
    T = promote_type(T1, T2, T3)
    absα = abs(T(α))
    if norm(z) < eps(real(T)) || norm(α) < eps(absα)
        return one(T)
    end
    ζ = inv(z)
    Nlo = β*ζ/α
    Dlo = β*ζ/α
    Tlo = Nlo/Dlo
    Nmid = ((β+1)*(2)*ζ - (α+1))*Nlo + (β+1)*(2)*ζ
    Dmid = ((β+1)*(2)*ζ - (α+1))*Dlo
    Tmid = Nmid/Dmid
    if norm(α+1) < eps(absα+1)
        return Tmid
    end
    Nmid /= α+1
    Dmid /= α+1
    Nhi = ((β+2)*(3)*ζ - (α+3))*Nmid + ((β+4)*ζ-1)*Nlo + (β+4)*ζ
    Dhi = ((β+2)*(3)*ζ - (α+3))*Dmid + ((β+4)*ζ-1)*Dlo
    Thi = Nhi/Dhi
    if norm(α+2) < eps(absα+2)
        return Thi
    end
    Nhi /= α+2
    Dhi /= α+2
    k = 2
    Nhi, Nmid, Nlo = ((β+k+1)*(k+2)*ζ-(α+2k+1))*Nhi + k*((β+2k+2)*ζ-1)*Nmid + k*(k-1)*ζ*Nlo + 2ζ, Nhi, Nmid
    Dhi, Dmid, Dlo = ((β+k+1)*(k+2)*ζ-(α+2k+1))*Dhi + k*((β+2k+2)*ζ-1)*Dmid + k*(k-1)*ζ*Dlo, Dhi, Dmid
    Thi, Tmid, Tlo = Nhi/Dhi, Thi, Tmid
    if norm(α+k+1) < eps(absα+k+1)
        return Thi
    end
    Nhi /= α+k+1
    Dhi /= α+k+1
    k += 1
    while k < kmax && errcheck(Tmid, Thi, 8eps(real(T)))
        Nhi, Nmid, Nlo = ((β+k+1)*(k+2)*ζ-(α+2k+1))*Nhi + k*((β+2k+2)*ζ-1)*Nmid + k*(k-1)*ζ*Nlo, Nhi, Nmid
        Dhi, Dmid, Dlo = ((β+k+1)*(k+2)*ζ-(α+2k+1))*Dhi + k*((β+2k+2)*ζ-1)*Dmid + k*(k-1)*ζ*Dlo, Dhi, Dmid
        Thi, Tmid, Tlo = Nhi/Dhi, Thi, Tmid
        if norm(α+k+1) < eps(absα+k+1)
            return Thi
        end
        Nhi /= α+k+1
        Dhi /= α+k+1
        k += 1
    end
    k < kmax || @warn "Rational approximation to "*pFq2string(Val(1), Val(1))*" reached the maximum type of ("*string(kmax, ", ", kmax)*")."
    return isfinite(Thi) ? Thi : isfinite(Tmid) ? Tmid : Tlo
end

# ₀F₂(α,β;z)
function pFqdrummond(::Tuple{}, β::Tuple{T1, T1}, z::T2; kmax::Int = KMAX) where {T1, T2}
    (α, β) = β
    T = promote_type(T1, T2)
    if norm(z) < eps(real(T))
        return one(T)
    end
    ζ = inv(z)
    Nlo = α*β*ζ
    Dlo = α*β*ζ
    Tlo = Nlo/Dlo
    k = 0
    Nmid2 = (ζ*(k+2)*(α+k+1)*(β+k+1)-1)*Nlo + (2*(α+1)*(β+1))*ζ
    Dmid2 = (ζ*(k+2)*(α+k+1)*(β+k+1)-1)*Dlo
    Tmid2 = Nmid2/Dmid2
    k = 1
    Nmid1 = (ζ*(k+2)*(α+k+1)*(β+k+1)-1)*Nmid2 + ζ*k*((k+1)*(α+β+2k)+(α+k)*(β+k)+α+β+3k+2)*Nlo + (3*(α+β+3)+(α+1)*(β+1))*ζ
    Dmid1 = (ζ*(k+2)*(α+k+1)*(β+k+1)-1)*Dmid2 + ζ*k*((k+1)*(α+β+2k)+(α+k)*(β+k)+α+β+3k+2)*Dlo
    Tmid1 = Nmid1/Dmid1
    k = 2
    Nhi = (ζ*(k+2)*(α+k+1)*(β+k+1)-1)*Nmid1 + ζ*k*((k+1)*(α+β+2k)+(α+k)*(β+k)+α+β+3k+2)*Nmid2 + ζ*k*(k-1)*(3k+α+β+1)*Nlo + (14+2*(α+β))*ζ
    Dhi = (ζ*(k+2)*(α+k+1)*(β+k+1)-1)*Dmid1 + ζ*k*((k+1)*(α+β+2k)+(α+k)*(β+k)+α+β+3k+2)*Dmid2 + ζ*k*(k-1)*(3k+α+β+1)*Dlo
    Thi = Nhi/Dhi
    k = 3
    Nhi, Nmid1, Nmid2, Nlo = (ζ*(k+2)*(α+k+1)*(β+k+1)-1)*Nhi + ζ*k*((k+1)*(α+β+2k)+(α+k)*(β+k)+α+β+3k+2)*Nmid1 + ζ*k*(k-1)*(3k+α+β+1)*Nmid2 + ζ*k*(k-1)*(k-2)*Nlo + 6ζ, Nhi, Nmid1, Nmid2
    Dhi, Dmid1, Dmid2, Dlo = (ζ*(k+2)*(α+k+1)*(β+k+1)-1)*Dhi + ζ*k*((k+1)*(α+β+2k)+(α+k)*(β+k)+α+β+3k+2)*Dmid1 + ζ*k*(k-1)*(3k+α+β+1)*Dmid2 + ζ*k*(k-1)*(k-2)*Dlo, Dhi, Dmid1, Dmid2
    Thi, Tmid1, Tmid2, Tlo = Nhi/Dhi, Thi, Tmid1, Tmid2
    k += 1
    while k < kmax && errcheck(Tmid1, Thi, 8eps(real(T)))
        Nhi, Nmid1, Nmid2, Nlo = (ζ*(k+2)*(α+k+1)*(β+k+1)-1)*Nhi + ζ*k*((k+1)*(α+β+2k)+(α+k)*(β+k)+α+β+3k+2)*Nmid1 + ζ*k*(k-1)*(3k+α+β+1)*Nmid2 + ζ*k*(k-1)*(k-2)*Nlo, Nhi, Nmid1, Nmid2
        Dhi, Dmid1, Dmid2, Dlo = (ζ*(k+2)*(α+k+1)*(β+k+1)-1)*Dhi + ζ*k*((k+1)*(α+β+2k)+(α+k)*(β+k)+α+β+3k+2)*Dmid1 + ζ*k*(k-1)*(3k+α+β+1)*Dmid2 + ζ*k*(k-1)*(k-2)*Dlo, Dhi, Dmid1, Dmid2
        Thi, Tmid1, Tmid2, Tlo = Nhi/Dhi, Thi, Tmid1, Tmid2
        k += 1
    end
    k < kmax || @warn "Rational approximation to "*pFq2string(Val(0), Val(2))*" reached the maximum type of ("*string(kmax, ", ", kmax)*")."
    return isfinite(Thi) ? Thi : isfinite(Tmid1) ? Tmid1 : isfinite(Tmid2) ? Tmid2 : Tlo
end

# ₂F₁(α,β,γ;z)
function pFqdrummond(α::Tuple{T1, T1}, β::Tuple{T2}, z::T3; kmax::Int = KMAX) where {T1, T2, T3}
    γ = β[1]
    (α, β) = α
    T = promote_type(T1, T2, T3)
    absα = abs(T(α))
    absβ = abs(T(β))
    if norm(z) < eps(real(T)) || norm(α*β) < eps(absα*absβ)
        return one(T)
    end
    μlo = T(α*β)/T(γ)
    Tlo = one(T)
    μmid = inv((2)*(γ+1)-(α+1)*(β+1)*z)
    Tmid = Tlo + (γ+1)*2z*μmid*μlo
    if norm((α+1)*(β+1)) < eps((absα+1)*(absβ+1))
        return Tmid
    end
    μmid *= (α+1)*(β+1)
    μhi = inv((3)*(γ+2)-((α+2)*(β+2)+(α+β+3))*z + ((γ+4)-(α+β+3)*z)*z*μmid)
    Thi = (((3)*(γ+2)-((α+2)*(β+2)+(α+β+3))*z)*Tmid + (((γ+4)-(α+β+3)*z)*z*Tlo + (γ+4)*z*z*μlo)*μmid)*μhi
    if norm((α+2)*(β+2)) < eps((absα+2)*(absβ+2))
        return Thi
    end
    μhi *= (α+2)*(β+2)
    k = 2
    μlo2 = μlo
    μhi, μmid, μlo = inv((k+2)*(γ+k+1)-((α+k+1)*(β+k+1)+k*(α+β+2k+1))*z + k*(((γ+2k+2)-(α+β+3k)*z)*z + (k-1)*(1-z)*z*z*μmid)*μhi), μhi, μmid
    Thi, Tmid, Tlo = (((k+2)*(γ+k+1)-((α+k+1)*(β+k+1)+k*(α+β+2k+1))*z)*Thi + (k*((γ+2k+2)-(α+β+3k)*z)*z*Tmid + (k*(k-1)*(1-z)*z*z*Tlo + 2z*z*z*μlo2)*μlo)*μmid)*μhi, Thi, Tmid
    if norm((α+k+1)*(β+k+1)) < eps((absα+k+1)*(absβ+k+1))
        return Thi
    end
    μhi *= (α+k+1)*(β+k+1)
    k += 1
    while k < kmax && errcheck(Tmid, Thi, 8eps(real(T)))
        μhi, μmid, μlo = inv((k+2)*(γ+k+1)-((α+k+1)*(β+k+1)+k*(α+β+2k+1))*z + k*(((γ+2k+2)-(α+β+3k)*z)*z + (k-1)*(1-z)*z*z*μmid)*μhi), μhi, μmid
        Thi, Tmid, Tlo = (((k+2)*(γ+k+1)-((α+k+1)*(β+k+1)+k*(α+β+2k+1))*z)*Thi + k*(((γ+2k+2)-(α+β+3k)*z)*z*Tmid + (k-1)*(1-z)*z*z*Tlo*μlo)*μmid)*μhi, Thi, Tmid
        if norm((α+k+1)*(β+k+1)) < eps((absα+k+1)*(absβ+k+1))
            return Thi
        end
        μhi *= (α+k+1)*(β+k+1)
        k += 1
    end
    k < kmax || @warn "Rational approximation to "*pFq2string(Val(2), Val(1))*" reached the maximum type of ("*string(kmax, ", ", kmax)*")."
    return isfinite(Thi) ? Thi : isfinite(Tmid) ? Tmid : Tlo
end

# ₘFₙ(α;β;z)
function pFqdrummond(α::AbstractVector{T1}, β::AbstractVector{T2}, z::T3, args...; kwds...) where {T1, T2, T3}
    pFqdrummond(Tuple(α), Tuple(β), z, args...; kwds...)
end
function pFqdrummond(α::NTuple{p, Any}, β::NTuple{q, Any}, z, args...; kwds...) where {p, q}
    T1 = isempty(α) ? Any : mapreduce(typeof, promote_type, α)
    T2 = isempty(β) ? Any : mapreduce(typeof, promote_type, β)
    pFqdrummond(T1.(α), T2.(β), z, args...; kwds...)
end
function pFqdrummond(α::NTuple{p, T1}, β::NTuple{q, T2}, z::T3; kmax::Int = KMAX) where {p, q, T1, T2, T3}
    T = promote_type(eltype(α), eltype(β), T3)
    absα = abs.(T.(α))
    if norm(z) < eps(real(T)) || norm(prod(α)) < eps(real(T)(prod(absα)))
        return one(T)
    end
    ζ = inv(z)
    r = max(p, q+1)
    N = zeros(T, r+2)
    D = zeros(T, r+2)
    R = zeros(T, r+2)
    N[r+2] = prod(β)*ζ/prod(α)
    D[r+2] = prod(β)*ζ/prod(α)
    R[r+2] = N[r+2]/D[r+2]
    absα = absα .+ 1
    α = α .+ 1
    β = β .+ 1
    err = real(T)(prod(absα))
    P = zeros(T, p+1)
    P[1] = T(prod(α))
    Q = zeros(T, q+2)
    Q[1] = T(2*prod(β))
    k = 0
    @inbounds while k ≤ r || (k < kmax && errcheck(R[r+1], R[r+2], 8eps(real(T))))
        for j in 1:r+1
            N[j] = N[j+1]
            D[j] = D[j+1]
            R[j] = R[j+1]
        end
        t1 = zero(T)
        for j in 0:min(k, q+1)
            t1 += Q[j+1]*N[r+1-j]
        end
        if k ≤ q+1
            t1 += Q[k+1]
        end
        t2 = zero(T)
        t2 += P[1]*N[r+1]
        for j in 1:min(k, p)
            t2 += P[j+1]*(N[r-j+2] + N[r-j+1])
        end
        N[r+2] = ζ*t1-t2
        t1 = zero(T)
        for j in 0:min(k, q+1)
            t1 += Q[j+1]*D[r-j+1]
        end
        t2 = zero(T)
        t2 += P[1]*D[r+1]
        for j in 1:min(k, p)
            t2 += P[j+1]*(D[r-j+2] + D[r-j+1])
        end
        D[r+2] = ζ*t1-t2
        R[r+2] = N[r+2]/D[r+2]
        if norm(P[1]) < eps(err)
            return R[r+2]
        end
        N[r+2] /= P[1]
        D[r+2] /= P[1]
        k += 1
        absα = absα .+ 1
        α = α .+ 1
        β = β .+ 1
        err = real(T)(prod(absα))
        t = T(prod(α))
        for j in 1:p
            s = ((k-j+1)*t - k*P[j])/j
            P[j] = t
            t = s
        end
        P[p+1] = t
        t = T((k+2)*prod(β))
        for j in 1:q+1
            s = ((k-j+1)*t - k*Q[j])/j
            Q[j] = t
            t = s
        end
        Q[q+2] = t
    end
    k < kmax || @warn "Rational approximation to "*pFq2string(Val(p), Val(q))*" reached the maximum type of ("*string(kmax, ", ", kmax)*")."
    return isfinite(R[r+2]) ? R[r+2] : R[r+1]
end

@deprecate drummond0F0(x; kwds...) pFqdrummond((), (), x; kwds...) false
@deprecate drummond1F0(α, x; kwds...) pFqdrummond((α, ), (), x; kwds...) false
@deprecate drummond0F1(β, x; kwds...) pFqdrummond((), (β, ), x; kwds...) false
@deprecate drummond2F0(α, β, x; kwds...) pFqdrummond((α, β), (), x; kwds...) false
@deprecate drummond1F1(α, β, x; kwds...) pFqdrummond((α, ), (β, ), x; kwds...) false
@deprecate drummond0F2(α, β, x; kwds...) pFqdrummond((), (α, β), x; kwds...) false
@deprecate drummond2F1(α, β, γ, x; kwds...) pFqdrummond((α, β), (γ, ), x; kwds...) false

@doc raw"""
    pFqweniger(α, β, z; kmax, γ = 2)
Compute the generalized hypergeometric function [`pFq`](@ref) by rational approximations of type (k, k) generated by a factorial Levin-type sequence transformation described in

> R. M. Slevinsky, [Fast and stable rational approximation of generalized hypergeometric functions](https://doi.org/10.1007/s11075-024-01808-w), *Numer. Algor.*, **98**:587–624, 2025.
"""
pFqweniger

# ₀F₀(;z), γ = 2.
function pFqweniger(::Tuple{}, ::Tuple{}, z::T; kmax::Int = KMAX) where T
    if norm(z) < eps(real(T))
        return one(T)
    end
    z2 = z*z
    μlo = one(T)
    Rlo = one(T)
    k = 0
    if iszero(2-z)
        μhi = inv(2-z)
        Rhi = Rlo + 2z*μhi
        k += 1
        μhi, μlo = inv(4k+2 + z2*μhi), μhi
        Rhi, Rlo = (4k+2)*2/z + Rlo, Rhi
        k += 1
        μhi, μlo = inv(4k+2 + z2*μhi), μhi
        Rhi, Rlo = Rhi + 2z*μhi, Rhi
        k += 1
    else
        μhi = inv(2-z)
        Rhi = Rlo + 2z*μhi
        k += 1
    end
    while k < kmax && errcheck(Rlo, Rhi, 8eps(real(T)))
        if iszero(4k+2 + z2*μhi)
            μhi, μlo = inv(4k+2 + z2*μhi), μhi
            cst = (4k+2)*Rhi + z2*Rlo*μlo
            Rhi, Rlo = cst*μhi, Rhi
            k += 1
            μhi, μlo = inv(4k+2 + z2*μhi), μhi
            Rhi, Rlo = (4k+2)*cst/z2 + Rlo, Rhi
            k += 1
            μhi, μlo = inv(4k+2 + z2*μhi), μhi
            Rhi, Rlo = Rhi + cst*μhi, Rhi
            k += 1
        else
            μhi, μlo = inv(4k+2 + z2*μhi), μhi
            Rhi, Rlo = ((4k+2)*Rhi + z2*Rlo*μlo)*μhi, Rhi
            k += 1
        end
    end
    k < kmax || @warn "Rational approximation to "*pFq2string(Val(0), Val(0))*" reached the maximum type of ("*string(kmax, ", ", kmax)*")."
    return isfinite(Rhi) ? Rhi : Rlo
end

# ₁F₀(α;z), γ = 2.
function pFqweniger(α::Tuple{T1}, ::Tuple{}, z::T2; kmax::Int = KMAX) where {T1, T2}
    α = α[1]
    T = promote_type(T1, T2)
    absα = abs(T(α))
    if norm(z) < eps(real(T)) || norm(α) < eps(absα)
        return one(T)
    end
    z2 = z*z
    μlo = α
    Rlo = one(T)
    k = 0
    if iszero(2-(α+1)*z)
        μhi = inv(2-(α+1)*z)
        Rhi = Rlo + 2z*μhi*μlo
        μhi *= α+1
        k += 1
        μhi, μlo = inv((2k+1)*(2-z) - (k-α)*z2*μhi), μhi
        Rhi, Rlo = Rlo - (2k+1)*(2-z)*2*α/(z*(α+1)*(k-α)), Rhi
        if norm(α+k+1) < eps(absα+k+1)
            return Rhi
        end
        μhi *= α+k+1
        k += 1
        μhi, μlo = inv((2k+1)*(2-z) - (k-α)*z2*μhi), μhi
        Rhi, Rlo = Rhi + 2z*(k-α)*α*(α+2)/((1-α)*(α+1))*μhi, Rhi
        if norm(α+k+1) < eps(absα+k+1)
            return Rhi
        end
        μhi *= α+k+1
        k += 1
    else
        μhi = inv(2-(α+1)*z)
        Rhi = Rlo + 2z*μhi*μlo
        if norm(α+1) < eps(absα+1)
            return Rhi
        end
        μhi *= α+1
        k += 1
    end
    while k < kmax && errcheck(Rlo, Rhi, 8eps(real(T)))
        if iszero((2k+1)*(2-z) - (k-α)*z2*μhi)
            μhi, μlo = inv((2k+1)*(2-z) - (k-α)*z2*μhi), μhi
            cst = (2k+1)*(2-z)*Rhi - (k-α)*z2*Rlo*μlo
            Rhi, Rlo = cst*μhi, Rhi
            if norm(α+k+1) < eps(absα+k+1)
                return Rhi
            end
            μhi *= α+k+1
            k += 1
            μhi, μlo = inv((2k+1)*(2-z) - (k-α)*z2*μhi), μhi # ✓
            Rhi, Rlo = Rlo - (2k+1)*(2-z)*cst/((k-α)*z2*(α+k)), Rhi
            if norm(α+k+1) < eps(absα+k+1)
                return Rhi
            end
            μhi *= α+k+1
            k += 1
            μhi, μlo = inv((2k+1)*(2-z) - (k-α)*z2*μhi), μhi
            Rhi, Rlo = Rhi + cst*(k-α)*(α+k)/((k-1-α)*(α+k-1))*μhi, Rhi
            if norm(α+k+1) < eps(absα+k+1)
                return Rhi
            end
            μhi *= α+k+1
            k += 1
        else
            μhi, μlo = inv((2k+1)*(2-z) - (k-α)*z2*μhi), μhi
            Rhi, Rlo = ((2k+1)*(2-z)*Rhi - (k-α)*z2*Rlo*μlo)*μhi, Rhi
            if norm(α+k+1) < eps(absα+k+1)
                return Rhi
            end
            μhi *= α+k+1
            k += 1
        end
    end
    k < kmax || @warn "Rational approximation to "*pFq2string(Val(1), Val{0}())*" reached the maximum type of ("*string(kmax, ", ", kmax)*")."
    return isfinite(Rhi) ? Rhi : Rlo
end

# ₀F₁(β;z), γ = 2.
function pFqweniger(::Tuple{}, β::Tuple{T1}, z::T2; kmax::Int = KMAX) where {T1, T2}
    β = β[1]
    T = promote_type(T1, T2)
    if norm(z) < eps(real(T))
        return one(T)
    end
    ζ = inv(z)
    Nlo = β*ζ
    Dlo = β*ζ
    Tlo = Nlo/Dlo
    b0 = T(2*(β+1))
    Nmid = (b0*ζ-1)*Nlo + b0*ζ
    Dmid = (b0*ζ-1)*Dlo
    Tmid = Nmid/Dmid
    k = 1
    #a1 = T(-4)
    b0 = T(6*(β+2))
    b1 = T(-6*β)
    t0 = b0*ζ+3
    t1 = b1*ζ+4
    Nhi = t0*Nmid + t1*Nlo + b1*ζ
    Dhi = t0*Dmid + t1*Dlo
    #Nhi = -Nmid - a1*(Nmid+Nlo) + ζ*(b0*Nmid + b1*Nlo) + b1*ζ
    #Dhi = -Dmid - a1*(Dmid+Dlo) + ζ*(b0*Dmid + b1*Dlo)
    Thi = Nhi/Dhi
    k = 2
    while k < 4 || (k < kmax && errcheck(Tmid, Thi, 8eps(real(T))))
        #a1 = T(-4k)/T(2k-1)
        a2 = T(2k+1)/T(2k-1)
        b0 = T(4k+2)*T(β+k+1)
        b1 = T(4k+2)*T(k-β-1)
        t0 = b0*ζ+a2
        t1 = b1*ζ+1
        Nhi, Nmid, Nlo = t0*Nhi + t1*Nmid - a2*Nlo, Nhi, Nmid
        Dhi, Dmid, Dlo = t0*Dhi + t1*Dmid - a2*Dlo, Dhi, Dmid
        #Nhi, Nmid, Nlo = -Nhi - a1*(Nhi+Nmid) - a2*(Nmid+Nlo) + ζ*(b0*Nhi + b1*Nmid), Nhi, Nmid
        #Dhi, Dmid, Dlo = -Dhi - a1*(Dhi+Dmid) - a2*(Dmid+Dlo) + ζ*(b0*Dhi + b1*Dmid), Dhi, Dmid
        Thi, Tmid, Tlo = Nhi/Dhi, Thi, Tmid
        k += 1
    end
    k < kmax || @warn "Rational approximation to "*pFq2string(Val{0}(), Val(1))*" reached the maximum type of ("*string(kmax, ", ", kmax)*")."
    return isfinite(Thi) ? Thi : isfinite(Tmid) ? Tmid : Tlo
end

# ₂F₀(α,β;z), γ = 2.
function pFqweniger(α::Tuple{T1, T1}, ::Tuple{}, z::T2; kmax::Int = KMAX) where {T1, T2}
    (α, β) = α
    T = promote_type(T1, T2)
    absα = abs(T(α))
    absβ = abs(T(β))
    if norm(z) < eps(real(T)) || norm(α*β) < eps(absα*absβ)
        return one(T)
    end
    μlo = T(α*β)
    Rlo = one(T)
    a0 = T((α+1)*(β+1))
    μmid = inv(2-a0*z)
    Rmid = Rlo + 2z*μmid*μlo
    if norm(a0) < eps((absα+1)*(absβ+1))
        return Rmid
    end
    μmid *= a0
    k = 1
    a0 = T((α+2)*(β+2))
    t0 = 6-(6-3*α*β)*z
    t1 = 6-2*T(2*α*β+α+β-1)*z
    μhi = inv(t0 - t1*z*μmid)
    Rhi = (t0*Rmid - (t1*Rlo + 6*z*μlo)*z*μmid)*μhi
    if norm(a0) < eps((absα+2)*(absβ+2))
        return Rhi
    end
    μhi *= a0
    k = 2
    z2 = z*z
    while k < 3 || (k < kmax && errcheck(Rmid, Rhi, 8eps(real(T))))
        a0 = T((α+k+1)*(β+k+1))
        t0 = (4k+2)-T((k*(α+β+3k)-(α+1)*(β+1)))*T(2k+1)/T(2k-1)*z
        t1 = (4k+2)+T(k*(3k-α-β)-(α+1)*(β+1))*z
        a2 = T((α+1-k)*(β+1-k))*T(2k+1)/T(2k-1)*z2
        μhi, μmid, μlo = inv(t0 - (t1 + a2*μmid)*z*μhi), μhi, μmid
        Rhi, Rmid, Rlo = (t0*Rhi - (t1*Rmid + a2*Rlo*μlo)*z*μmid)*μhi, Rhi, Rmid
        if norm(a0) < eps((absα+k+1)*(absβ+k+1))
            return Rhi
        end
        μhi *= a0
        k += 1
    end
    k < kmax || @warn "Rational approximation to "*pFq2string(Val(2), Val{0}())*" reached the maximum type of ("*string(kmax, ", ", kmax)*")."
    return isfinite(Rhi) ? Rhi : isfinite(Rmid) ? Rmid : Rlo
end

# ₁F₁(α,β;z), γ = 2.
function pFqweniger(α::Tuple{T1}, β::Tuple{T2}, z::T3; kmax::Int = KMAX) where {T1, T2, T3}
    α = α[1]
    β = β[1]
    T = promote_type(T1, T2, T3)
    absα = abs(T(α))
    if norm(z) < eps(real(T)) || norm(α) < eps(absα)
        return one(T)
    end
    ζ = inv(z)
    Nlo = β*ζ/α
    Dlo = β*ζ/α
    Tlo = Nlo/Dlo
    a0 = T(α+1)
    b0 = T(2*(β+1))
    Nmid = (b0*ζ-a0)*Nlo + b0*ζ
    Dmid = (b0*ζ-a0)*Dlo
    Tmid = Nmid/Dmid
    if norm(a0) < eps(absα+1)
        return Tmid
    end
    Nmid /= a0
    Dmid /= a0
    k = 1
    a0 = T(α+2)
    #a1 = -T(4α+2)
    b0 = T(6*(β+2))
    b1 = T(-6*β)
    t0 = b0*ζ+3α
    t1 = b1*ζ+4α+2
    Nhi = t0*Nmid + t1*Nlo + b1*ζ
    Dhi = t0*Dmid + t1*Dlo
    #Nhi = -a0*Nmid - a1*(Nmid+Nlo) + ζ*(b0*Nmid + b1*Nlo) + b1*ζ
    #Dhi = -a0*Dmid - a1*(Dmid+Dlo) + ζ*(b0*Dmid + b1*Dlo)
    Thi = Nhi/Dhi
    if norm(a0) < eps(absα+2)
        return Thi
    end
    Nhi /= a0
    Dhi /= a0
    k = 2
    while k < 5 || (k < kmax && errcheck(Tmid, Thi, 8eps(real(T))))
        a0 = T(α+k+1)
        #a1 = -T(2α+1)*T(2k)/T(2k-1)
        a2 = T(α+1-k)*T(2k+1)/T(2k-1)
        b0 = T(4k+2)*T(β+k+1)
        b1 = T(4k+2)*T(k-β-1)
        t0 = b0*ζ+a2
        t1 = b1*ζ+a0
        Nhi, Nmid, Nlo = t0*Nhi + t1*Nmid - a2*Nlo, Nhi, Nmid
        Dhi, Dmid, Dlo = t0*Dhi + t1*Dmid - a2*Dlo, Dhi, Dmid
        #Nhi, Nmid, Nlo = -a0*Nhi - a1*(Nhi+Nmid) - a2*(Nmid+Nlo) + ζ*(b0*Nhi + b1*Nmid), Nhi, Nmid
        #Dhi, Dmid, Dlo = -a0*Dhi - a1*(Dhi+Dmid) - a2*(Dmid+Dlo) + ζ*(b0*Dhi + b1*Dmid), Dhi, Dmid
        Thi, Tmid, Tlo = Nhi/Dhi, Thi, Tmid
        if norm(a0) < eps(absα+k+1)
            return Thi
        end
        Nhi /= a0
        Dhi /= a0
        k += 1
    end
    k < kmax || @warn "Rational approximation to "*pFq2string(Val(1), Val(1))*" reached the maximum type of ("*string(kmax, ", ", kmax)*")."
    return isfinite(Thi) ? Thi : isfinite(Tmid) ? Tmid : Tlo
end

# ₀F₂(α,β;z), algorithm γ = 2.
function pFqweniger(α::Tuple{}, β::Tuple{T1, T1}, z::T2; kmax::Int = KMAX) where {T1, T2}
    (α, β) = β
    T = promote_type(T1, T2)
    if norm(z) < eps(real(T))
        return one(T)
    end
    ζ = inv(z)
    Nlo = α*β*ζ
    Dlo = α*β*ζ
    Tlo = Nlo/Dlo
    a0 = T(1)
    b0 = 2*T(α+1)*T(β+1)
    Nmid2 = (b0*ζ-a0)*Nlo + b0*ζ
    Dmid2 = (b0*ζ-a0)*Dlo
    Tmid2 = Nmid2/Dmid2
    k = 1
    b0 = 6*T(α+2)*T(β+2)
    b1 = 6*T(α+β+3)
    t0 = b0*ζ
    t1 = b1*ζ+1
    Nmid1 = t0*Nmid2 + t1*Nlo + b1*ζ
    Dmid1 = t0*Dmid2 + t1*Dlo
    Tmid1 = Nmid1/Dmid1
    k = 2
    a2 = T(5)/T(3)
    b0 = 10*T(α+3)*T(β+3)
    b1 = -10*(T(α-1)*β-T(α+11))
    b2 = T(40)
    t0 = b0*ζ+T(5)/T(3)
    t1 = b1*ζ+1
    t2 = b2*ζ-a2
    Nhi = t0*Nmid1 + t1*Nmid2 + t2*Nlo + b2*ζ
    Dhi = t0*Dmid1 + t1*Dmid2 + t2*Dlo
    Thi = Nhi/Dhi
    k = 3
    while k < 6 || (k < kmax && errcheck(Tmid1, Thi, 8eps(real(T))))
        a3 = -k*T(2k+1)/T((k-1)*(2k-3))
        b0 = T(4k+2)*T(α+k+1)*T(β+k+1)
        b1 = (T(k*(k-1))-T(α+1)*T(β+1))*T(2k-1)*T(4k+2)/T(k-1)
        b2 = T(k-α-2)*T(k-β-2)*T(4k+2)*k/T(k-1)
        t0 = b0*ζ+T(2k+1)/T(k-1)
        t1 = b1*ζ-3*T(2k-1)/T((k-1)*(2k-3))
        t2 = b2*ζ-T(2k+1)/T(k-1)
        Nhi, Nmid1, Nmid2, Nlo = t0*Nhi + t1*Nmid1 + t2*Nmid2 - a3*Nlo, Nhi, Nmid1, Nmid2
        Dhi, Dmid1, Dmid2, Dlo = t0*Dhi + t1*Dmid1 + t2*Dmid2 - a3*Dlo, Dhi, Dmid1, Dmid2
        Thi, Tmid1, Tmid2, Tlo = Nhi/Dhi, Thi, Tmid1, Tmid2
        k += 1
    end
    k < kmax || @warn "Rational approximation to "*pFq2string(Val{0}(), Val(2))*" reached the maximum type of ("*string(kmax, ", ", kmax)*")."
    return isfinite(Thi) ? Thi : isfinite(Tmid1) ? Tmid1 : isfinite(Tmid2) ? Tmid2 : Tlo
end

# ₂F₁(α,β,γ;z), algorithm γ = 2.
function pFqweniger(α::Tuple{T1, T1}, β::Tuple{T2}, z::T3; kmax::Int = KMAX) where {T1, T2, T3}
    γ = β[1]
    (α, β) = α
    T = promote_type(T1, T2, T3)
    absα = abs(T(α))
    absβ = abs(T(β))
    if norm(z) < eps(real(T)) || norm(α*β) < eps(absα*absβ)
        return one(T)
    end
    μlo = T(α*β)/T(γ)
    Rlo = one(T)
    a0 = T((α+1)*(β+1))
    b0 = T(2*(γ+1))
    μmid = inv(b0-a0*z)
    Rmid = Rlo + b0*z*μmid*μlo
    if norm(a0) < eps((absα+1)*(absβ+1))
        return Rmid
    end
    μmid *= a0
    k = 1
    a0 = T((α+2)*(β+2))
    b0 = T(6*(γ+2))
    b1 = T(-6*γ)
    t0 = b0-(6-3*α*β)*z
    t1 = b1+2*T(2*α*β+α+β-1)*z
    μhi = inv(t0 + t1*z*μmid)
    Rhi = (t0*Rmid + (t1*Rlo + b1*z*μlo)*z*μmid)*μhi
    if norm(a0) < eps((absα+2)*(absβ+2))
        return Rhi
    end
    μhi *= a0
    k = 2
    z2 = z*z
    while k < 5 || (k < kmax && errcheck(Rmid, Rhi, 8eps(real(T))))
        a0 = T((α+k+1)*(β+k+1))
        a2 = T((α+1-k)*(β+1-k))*T(2k+1)/T(2k-1)*z2
        b0 = T(4k+2)*T(γ+k+1)
        b1 = T(4k+2)*T(k-γ-1)
        t0 = b0-T((k*(α+β+3k)-(α+1)*(β+1)))*T(2k+1)/T(2k-1)*z
        t1 = b1-T(k*(3k-α-β)-(α+1)*(β+1))*z
        μhi, μmid, μlo = inv(t0 + (t1 - a2*μmid)*z*μhi), μhi, μmid
        Rhi, Rmid, Rlo = (t0*Rhi + (t1*Rmid - a2*Rlo*μlo)*z*μmid)*μhi, Rhi, Rmid
        if norm(a0) < eps((absα+k+1)*(absβ+k+1))
            return Rhi
        end
        μhi *= a0
        k += 1
    end
    k < kmax || @warn "Rational approximation to "*pFq2string(Val(2), Val(1))*" reached the maximum type of ("*string(kmax, ", ", kmax)*")."
    return isfinite(Rhi) ? Rhi : isfinite(Rmid) ? Rmid : Rlo
end

# ₃F₂(α,β,γ,δ,λ;z), algorithm γ = 2.
function pFqweniger(α::Tuple{T1, T1, T1}, β::Tuple{T2, T2}, z::T3; kmax::Int = KMAX) where {T1, T2, T3}
    (δ, λ) = β
    (α, β, γ) = α
    T = promote_type(T1, T2, T3)
    absα = abs(T(α))
    absβ = abs(T(β))
    absγ = abs(T(γ))
    if norm(z) < eps(real(T)) || norm(α*β*γ) < eps(absα*absβ*absγ)
        return one(T)
    end
    μlo = T(α*β*γ)/T(δ*λ)
    Rlo = one(T)
    a0 = T(α+1)*T(β+1)*T(γ+1)
    b0 = 2*T(δ+1)*T(λ+1)
    μmid2 = inv(b0-a0*z)
    Rmid2 = Rlo + b0*z*μmid2*μlo
    if norm(a0) < eps((absα+1)*(absβ+1)*(absγ+1))
        return Rmid2
    end
    μmid2 *= a0
    k = 1
    a0 = T(α+2)*T(β+2)*T(γ+2)
    a1 = (T(1-β)*γ+β+5)*α+T(5+β)*γ+5*T(β)+13
    b0 = 6*T(δ+2)*T(λ+2)
    b1 = 6*T(δ+λ+3)
    t0 = b0-3*(T(β+γ+3)*α+T(β+3)*γ+3*T(β)+7)*z
    t1 = b1-a1*z
    μmid1 = inv(t0 + t1*z*μmid2)
    Rmid1 = (t0*Rmid2 + (t1*Rlo + b1*z*μlo)*z*μmid2)*μmid1
    if norm(a0) < eps((absα+2)*(absβ+2)*(absγ+2))
        return Rmid1
    end
    μmid1 *= a0
    k = 2
    a0 = T(α+3)*T(β+3)*T(γ+3)
    a2 = 5*(T(γ-1)*T(β-1)*α+T(1-β)*γ+T(β)+23)/3
    b0 = 10*T(δ+3)*T(λ+3)
    b1 = -10*(T(δ-1)*λ-T(δ+11))
    b2 = T(40)
    t0 = b0+5*((T(β-1)*γ-T(β+11))*α-T(β+11)*γ-11*T(β)-49)/3*z
    t1 = b1+((T(3+β)*γ+T(3*β-11))*α+T(3*β-11)*γ-11*T(β)-93)*z
    t2 = b2-a2*z
    μhi = inv(t0 + (t1 + t2*z*μmid2)*z*μmid1)
    Rhi = (t0*Rmid1 + (t1*Rmid2 + (t2*Rlo + b2*z*μlo)*z*μmid2)*z*μmid1)*μhi
    if norm(a0) < eps((absα+3)*(absβ+3)*(absγ+3))
        return Rhi
    end
    μhi *= a0
    k = 3
    z2 = z*z
    while k < 6 || (k < kmax && errcheck(Rmid1, Rhi, 8eps(real(T))))
        a0 = T(α+k+1)*T(β+k+1)*T(γ+k+1)
        a3 = T(k-α-2)*T(k-β-2)*T(k-γ-2)*k*T(2k+1)/T((k-1)*(2k-3))*z2
        b0 = T(4k+2)*T(δ+k+1)*T(λ+k+1)
        b1 = (T(k*(k-1))-T(δ+1)*T(λ+1))*T(2k-1)*T(4k+2)/T(k-1)
        b2 = T(k-δ-2)*T(k-λ-2)*T(4k+2)*k/T(k-1)
        t0 = b0-((T(2k+α+β+γ)*k-T(α+β+γ+2))*k-T(γ+1)*T(α+1)*T(β+1))*T(2k+1)/T(k-1)*z
        t1 = b1-(((T(6k-12)*k+(T(-2β-2γ-3)*α+T(-2β-3)*γ-3β-2))*k+(T(2β+2γ+3)*α+T(2β+3)*γ+3β+8))*k+3*T(γ+1)*T(α+1)*T(β+1))*T(2k-1)/T((k-1)*(2k-3))*z
        t2 = b2-((T(2k-α-β-γ-6)*k+T(α+β+γ+4))*k+T(γ+1)*T(α+1)*T(β+1))*T(2k+1)/T(k-1)*z
        μhi, μmid1, μmid2, μlo = inv(t0 + (t1 + (t2 - a3*μmid2)*z*μmid1)*z*μhi), μhi, μmid1, μmid2
        Rhi, Rmid1, Rmid2, Rlo = (t0*Rhi + (t1*Rmid1 + (t2*Rmid2 - a3*Rlo*μlo)*z*μmid2)*z*μmid1)*μhi, Rhi, Rmid1, Rmid2
        if norm(a0) < eps((absα+k+1)*(absβ+k+1)*(absγ+k+1))
            return Rhi
        end
        μhi *= a0
        k += 1
    end
    k < kmax || @warn "Rational approximation to "*pFq2string(Val(3), Val(2))*" reached the maximum type of ("*string(kmax, ", ", kmax)*")."
    return isfinite(Rhi) ? Rhi : isfinite(Rmid1) ? Rmid1 : isfinite(Rmid2) ? Rmid2 : Rlo
end

# ₘFₙ(α;β;z)
function pFqweniger(α::AbstractVector{T1}, β::AbstractVector{T2}, z::T3, args...; kwds...) where {T1, T2, T3}
    pFqweniger(Tuple(α), Tuple(β), z, args...; kwds...)
end
function pFqweniger(α::NTuple{p, Any}, β::NTuple{q, Any}, z, args...; kwds...) where {p, q}
    T1 = isempty(α) ? Any : mapreduce(typeof, promote_type, α)
    T2 = isempty(β) ? Any : mapreduce(typeof, promote_type, β)
    pFqweniger(T1.(α), T2.(β), z, args...; kwds...)
end
function pFqweniger(α::NTuple{p, T1}, β::NTuple{q, T2}, z::T3; kmax::Int = KMAX, γ::T4 = 2) where {p, q, T1, T2, T3, T4}
    T = promote_type(eltype(α), eltype(β), T3, T4)
    absα = abs.(T.(α))
    if norm(z) < eps(real(T)) || norm(prod(α)) < eps(real(T)(prod(absα)))
        return one(T)
    end
    γ = T(γ)
    ζ = inv(z)
    r = max(p, q+1)
    N = zeros(T, r+3)
    D = zeros(T, r+3)
    R = zeros(T, r+3)
    N[r+3] = prod(β)*ζ/prod(α)/(γ-1)
    D[r+3] = prod(β)*ζ/prod(α)/(γ-1)
    R[r+3] = N[r+3]/D[r+3]
    err = real(T)(1)
    @inbounds for j in 1:p
        err *= absα[j]+1
    end
    P̂ = zeros(T, r+2)
    t = T(1)
    @inbounds for j in 1:p
        t *= α[j]+1
    end
    P̂[1] = t
    Q = zeros(T, r+1)
    t = T(2)
    @inbounds for j in 1:q
        t *= β[j]+1
    end
    Q[1] = t
    P̂R = γ+2
    QR = T(1)
    k = 0
    @inbounds while k ≤ r+2 || (k < kmax && errcheck(R[r+2], R[r+3], 8eps(real(T))))
        for j in 1:r+2
            N[j] = N[j+1]
            D[j] = D[j+1]
            R[j] = R[j+1]
        end
        t1 = zero(T)
        for j in 0:r
            t1 += Q[j+1]*(γ+2k-2j-1)*N[r-j+2]
        end
        if k ≤ r
            for j in 0:k
                t2 = one(T)
                for i in 1:q
                    t2 *= β[i]+j+1
                end
                t2 *= j+2
                t1 += binomial(k, j)*(-one(T))^(k-j)*t2
            end
        end
        t2 = zero(T)
        t2 += P̂[1]*(γ+k-1)*N[r+2]
        for j in 1:r+1
            t2 += P̂[j+1]*(N[r-j+3]+(γ+k-j-1)*N[r-j+2])
        end
        N[r+3] = ζ*t1-t2
        t1 = zero(T)
        for j in 0:r
            t1 += Q[j+1]*(γ+2k-2j-1)*D[r-j+2]
        end
        t2 = zero(T)
        t2 += P̂[1]*(γ+k-1)*D[r+2]
        for j in 1:r+1
            t2 += P̂[j+1]*(D[r-j+3]+(γ+k-j-1)*D[r-j+2])
        end
        D[r+3] = ζ*t1-t2
        R[r+3] = N[r+3]/D[r+3]
        if norm(P̂[1]) < eps(err)
            return R[r+3]
        end
        N[r+3] /= P̂[1]
        D[r+3] /= P̂[1]
        k += 1
        err = real(T)(1)
        for j in 1:p
            err *= absα[j]+k+1
        end
        if k ≤ r+1
            t2 = T(1)
            for j in 1:p
                t2 *= α[j]+k+1
            end
            t2 /= P̂R
            P̂R *= ((γ+2k+1)*(γ+2k+2))/(γ+k+1)
            t1 = k*((γ+2k)*t2 - P̂[1])
            for j in 2:k
                s = ((k-j+1)*((γ+2k-j+1)*t1+k*P̂[j-1]) - k*P̂[j])/j
                P̂[j-1] = t2
                t2 = t1
                t1 = s
            end
            P̂[k] = t2
            P̂[k+1] = t1
            t2 = T(k+2)
            for j in 1:q
                t2 *= β[j]+k+1
            end
            QR *= ((γ+2k-2)*(γ+2k-1))/(γ+k-1)
            t2 /= QR
            t1 = k*((γ+2k-1)*t2 - Q[1])
            for j in 2:min(k, r)
                s = ((k-j+1)*((γ+2k-j)*t1+k*Q[j-1]) - k*Q[j])/j
                Q[j-1] = t2
                t2 = t1
                t1 = s
            end
            Q[min(k, r)] = t2
            Q[min(k, r)+1] = t1
        else
            t2 = γ+k
            for j in 1:p
                t2 *= α[j]+k+1
            end
            t2 /= P̂R
            P̂R *= ((γ+2k+1)*(γ+2k+2))/((γ+2k-r-1)*(γ+2k-r))
            t1 = k*((γ+2k)*t2 - (γ+2k-1-r-2)*P̂[1])
            for j in 2:r+1
                s = ((k-j+1)*((γ+2k-j+1)*t1-(r-j+3)*k*P̂[j-1]) - (γ+2k-j-r-2)*k*P̂[j])/j
                P̂[j-1] = t2
                t2 = t1
                t1 = s
            end
            P̂[r+1] = t2
            P̂[r+2] = t1
            t2 = T(k+2)
            for j in 1:q
                t2 *= β[j]+k+1
            end
            QR *= ((γ+2k-2)*(γ+2k-1))/((γ+2k-r-3)*(γ+2k-r-2))
            t2 /= QR
            t1 = k*((γ+2k-1)*t2 - (γ+2k-1-r-2)*Q[1])
            for j in 2:r
                s = ((k-j+1)*((γ+2k-j)*t1-(r-j+2)*k*Q[j-1]) - (γ+2k-j-r-2)*k*Q[j])/j
                Q[j-1] = t2
                t2 = t1
                t1 = s
            end
            Q[r] = t2
            Q[r+1] = t1
        end
    end
    k < kmax || @warn "Rational approximation to "*pFq2string(Val(p), Val(q))*" reached the maximum type of ("*string(kmax, ", ", kmax)*")."
    return isfinite(R[r+3]) ? R[r+3] : R[r+2]
end

@doc raw"""
    pFq(α, β, z)
Compute the generalized hypergeometric function, defined by
```math
{}_pF_q(α, β, z) = \sum_{k=0}^\infty \dfrac{(\alpha_1)_k\cdots(\alpha_p)_k}{(\beta_1)_k\cdots(\beta_q)_k}\dfrac{z^k}{k!},
```
where the series converges and elsewhere by analytic continuation.

External links: [DLMF](https://dlmf.nist.gov/16.2.1), [Wikipedia](https://en.wikipedia.org/wiki/Generalized_hypergeometric_function).

# Examples
```jldoctest
julia> pFq((), (), 0.1) # ≡ exp(0.1)
1.1051709180756477

julia> pFq((0.5, ), (), 1.0+0.001im) # ≡ exp(-0.5*log1p(-1.0-0.001im))
22.360679774997894 + 22.36067977499789im

julia> pFq((), (1.5, ), -π^2/4) # A root of a spherical Bessel function
4.042865030283967e-17

julia> pFq((), (1.5, ), -big(π)^2/4) # In extended precision
8.674364372518869408017614476652675180406967418943475242812160199356160822272727e-78

julia> pFq((1, ), (2, ), 0.01) # ≡ expm1(0.01)/0.01
1.0050167084168058

julia> pFq((1/3, ), (2/3, ), -1000) # A confluent hypergeometric with large argument
0.050558053946448855

julia> pFq((1, 2), (4, ), 1) # a well-poised ₂F₁
2.9999999999999996

julia> pFq((1, 2+im), (3.5, ), exp(im*π/3)) # ₂F₁ at that special point in ℂ
0.6786952632946592 + 0.4523504929285015im

julia> pFq((1, 2+im), (3.5, ), exp(im*big(π)/3)) # More digits, you say?
0.6786952632946589823300834090168381068073515492901393549193461972311801512528996 + 0.4523504929285013648194489713901658143893464679689810112119412310631860619947939im

julia> pFq((1, 2+im, 2.5), (3.5, 4), exp(im*π/3)) # ₃F₂ because why not
0.8434434031615691 + 0.34175507615463174im

julia> pFq((1, 2+im, 2.5), (3.5, 4), exp(im*big(π)/3)) # Also in extended precision
0.8434434031615690763389963048175253868863156451003855955719081209861492349268002 + 0.3417550761546319732614495656712509723030350666571102474299311122586948108413206im

julia> pFq((1, 1), (), -1) # A divergent series
0.5963473623231942

julia> pFq((1, 1), (), -big(1))
0.5963473623231940743410784993692793760741778601525487815734849104823272191142015
```
"""
pFq

pFq(::Tuple{}, ::Tuple{}, z; kwds...) = exp(z)
pFq(α::NTuple{1}, ::Tuple{}, z; kwds...) = isinteger(α[1]) ? (1-z)^-α[1] : exp(-α[1]*log1p(-z))
pFq(α::NTuple{1, <: Integer}, ::Tuple{}, z; kwds...) = (1-z)^-α[1]
pFq(α::NTuple{1}, β::NTuple{1}, z; kwds...) = _₁F₁(α[1], β[1], z; kwds...)
pFq(α::NTuple{2, Any}, β::NTuple{1}, z; kwds...) = _₂F₁(α[1], α[2], β[1], z; kwds...)

function pFq(α::NTuple{p, Any}, β::NTuple{q, Any}, z; kwds...) where {p, q}
    T1 = isempty(α) ? Any : mapreduce(typeof, promote_type, α)
    T2 = isempty(β) ? Any : mapreduce(typeof, promote_type, β)
    pFq(T1.(α), T2.(β), z; kwds...)
end
function pFq(α::NTuple{p, T1}, β::Tuple{}, z; kwds...) where {p, T1}
    z = float(z)
    T = promote_type(T1, typeof(z))
    if isterminating(α)
        return pFqmaclaurin(α, β, z, getterminatinglength(α); kwds...)::T
    else
        return pFqweniger(α, β, z; kwds...)::T
    end
end
function pFq(α::Tuple{}, β::NTuple{q, T2}, z; kwds...) where {q, T2}
    z = float(z)
    T = promote_type(T2, typeof(z))
    if real(z) > 0
        return pFqmaclaurin(α, β, z; kwds...)::T
    else
        return pFqweniger(α, β, z; kwds...)::T
    end
end
function pFq(α::NTuple{p, T1}, β::NTuple{q, T2}, z; kwds...) where {p, q, T1, T2}
    z = float(z)
    T = promote_type(T1, T2, typeof(z))
    if isacommonparameter(α, β)
        return pFq(cancelacommonparameter(α, β)..., z; kwds...)::T
    end
    if isterminating(α)
        return pFqmaclaurin(α, β, z, getterminatinglength(α); kwds...)::T
    end
    if p ≤ q
        if real(z) > 0
            return pFqmaclaurin(α, β, z; kwds...)::T
        else
            return pFqweniger(α, β, z; kwds...)::T
        end
    elseif p == q + 1
        if ispositivelybalanced(α, β)
            #return pFqconformalrationalgeneralizedeuler(α, β, z; kwds...)::T
            return pFqconformalrational(α, β, z; kwds...)::T
        else
            return pFqconformalrational(α, β, z; kwds...)::T
        end
    else
        return pFqweniger(α, β, z; kwds...)::T
    end
end

pFq(α::AbstractVector, β::AbstractVector, z; kwds...) = pFq(Tuple(α), Tuple(β), z; kwds...)

"""
Compute the generalized hypergeometric function `₃F₂(a₁, 1, 1, b₁, 2, z)`.
"""
_₃F₂(a₁, b₁, z; kwds...) = _₃F₂(a₁, 1, 1, b₁, 2, z; kwds...)
"""
Compute the generalized hypergeometric function `₃F₂(a₁, a₂, a₃, b₁, b₂; z)`.
"""
_₃F₂(a₁, a₂, a₃, b₁, b₂, z; kwds...) = pFq((a₁, a₂, a₃), (b₁, b₂), z; kwds...)

"""
Implement `p(z, ::Val{m}) = 1-(1-z)^(1/m)` without subtractive cancellation near the origin.
"""
function p(z)
    return p(z, Val(4))
end
function p(z, ::Val{2})
    t = sqrt(1-z)
    return z/(1+t)
end
function p(z, ::Val{3})
    t = (one(z)-z)^(one(z)/3)
    u = one(z)+t
    return z/muladd(t, u, one(z))
end
function p(z, ::Val{4})
    t = (one(z)-z)^(one(z)/4)
    u = one(z)+t
    return z/muladd(t, muladd(t, u, one(z)), one(z))
end
@generated function p(z, ::Val{m}) where m
    str = """
    begin
        t = (one(z) - z)^(one(z) / m)
        u = one(t) + t
        s = u
        for k in 3:m
            s = muladd(t, s, one(z))
        end
        return z / s
    end"""
    Meta.parse(str)
end

"""
Implement `r(z, ::Val{m}) = (1-(1-z)^(1/m))/(1+(1-z)^(1/m))` without subtractive cancellation near the origin.
"""
function r(z)
    return r(z, Val(4))
end
function r(z, ::Val{2})
    t = sqrt(1-z)
    return z/(1+t)^2
end
function r(z, ::Val{3})
    t = (one(z)-z)^(one(z)/3)
    u = one(z)+t
    return z/(u*muladd(t, u, one(z)))
end
function r(z, ::Val{4})
    t = (one(z)-z)^(one(z)/4)
    u = one(z)+t
    return z/(u*muladd(t, muladd(t, u, one(z)), one(z)))
end
@generated function r(z, ::Val{m}) where m
    str = """
    begin
        t = (one(z) - z)^(one(z) / m)
        u = one(t) + t
        s = u
        for k in 3:m
            s = muladd(t, s, one(z))
        end
        return z / (u * s)
    end"""
    Meta.parse(str)
end

"""
Maclaurin series of ₚ₊₁Fₚ(α, β; z = 1 - (1-ζ)^m)
"""
pFqconformalpolynomial(α, β, z; kwds...) = pFqconformalpolynomial(α, β, z, Val(4); kwds...)
function pFqconformalpolynomial(α::Tuple{Any, Vararg{Any, q}}, β::NTuple{q, Any}, z, m; kwds...) where q
    T1 = isempty(α) ? Any : mapreduce(typeof, promote_type, α)
    T2 = isempty(β) ? Any : mapreduce(typeof, promote_type, β)
    pFqconformalpolynomial(T1.(α), T2.(β), z, m; kwds...)
end


function pFqconformalpolynomial(α::Tuple{T1, T1}, β::Tuple{T2}, z::T3, ::Val{2}; kmax::Int = KMAX) where {T1, T2, T3}
    T = promote_type(T1, T2, T3)
    γ = T(β[1])
    (α, β) = T.(α)
    if abs(z) < eps(real(T))
        return one(T)
    end
    ζ = p(T(z), Val(2))
    B = 1 + 2*(α+β)
    C = 4*α*β
    k = 0
    wlo = zero(T)
    whi = one(T)
    Slo = one(T)
    whi, wlo = (ζ/(2*γ))*C*whi, whi
    Shi = Slo + whi
    k = 1
    while (k < kmax && errcheck(Shi, Slo, 8eps(real(T))))
        alo = -(k+B-2)*(k-1) - C
        ahi = (2*B+3*k-3)*k + C
        whi, wlo = (ζ/(2*(k+1)*(k+γ)))*(ahi*whi+ζ*alo*wlo), whi
        Shi, Slo = Shi + whi, Shi
        k += 1
    end
    k < kmax || @warn "Iteration limit reached before convergence."
    return Shi
end

function pFqconformalpolynomial(α::Tuple{T1, T1}, β::Tuple{T2}, z::T3, ::Val{3}; kmax::Int = KMAX) where {T1, T2, T3}
    T = promote_type(T1, T2, T3)
    γ = T(β[1])
    (α, β) = T.(α)
    if abs(z) < eps(real(T))
        return one(T)
    end
    ζ = p(T(z), Val(3))
    B = 1 + 3*(α+β)
    C = 9*α*β
    k = 0
    wlo = zero(T)
    wmid = zero(T)
    whi = one(T)
    Slo = one(T)
    whi, wmid, wlo = (ζ/(3*γ))*C*whi, whi, wmid
    Shi = Slo + whi
    k = 1
    while (k < kmax && errcheck(Shi, Slo, 8eps(real(T))))
        alo = (k+B-3)*(k-2)+C
        amid = -(4*k+3*B-8)*(k-1) - 2*C
        ahi = (6*k+3*B-6)*k + C
        whi, wmid, wlo = (ζ/(3*(k+1)*(k+γ)))*(ahi*whi+ζ*(amid*wmid+ζ*alo*wlo)), whi, wmid
        Shi, Slo = Shi + whi, Shi
        k += 1
    end
    k < kmax || @warn "Iteration limit reached before convergence."
    return Shi
end

function pFqconformalpolynomial(α::Tuple{T1, T1}, β::Tuple{T2}, z::T3, ::Val{4}; kmax::Int = KMAX) where {T1, T2, T3}
    T = promote_type(T1, T2, T3)
    γ = T(β[1])
    (α, β) = T.(α)
    if abs(z) < eps(real(T))
        return one(T)
    end
    ζ = p(T(z), Val(4))
    B = 1 + 4*(α+β)
    C = 16*α*β
    k = 0
    wlo = zero(T)
    wmid2 = zero(T)
    wmid1 = zero(T)
    whi = one(T)
    Slo = one(T)
    whi, wmid1, wmid2, wlo = (ζ/(4*γ))*C*whi, whi, wmid1, wmid2
    Shi = Slo + whi
    k = 1
    while (k < kmax && errcheck(Shi, Slo, 8eps(real(T))))
        alo = -(k+B-4)*(k-3) - C
        amid2 = (5*k+4*B-15)*(k-2) + 3*C
        amid1 = -(10*k+6*B-20)*(k-1) - 3*C
        ahi = (10*k+4*B-10)*k + C
        whi, wmid1, wmid2, wlo = (ζ/(4*(k+1)*(k+γ)))*(ahi*whi+ζ*(amid1*wmid1+ζ*(amid2*wmid2+ζ*alo*wlo))), whi, wmid1, wmid2
        Shi, Slo = Shi + whi, Shi
        k += 1
    end
    k < kmax || @warn "Iteration limit reached before convergence."
    return Shi
end

"""
Maclaurin series of ₚ₊₁Fₚ(α, β; z = 1 - ((1-ζ)/(1+ζ))^m)
"""
pFqconformalrational(α, β, z; kwds...) = pFqconformalrational(α, β, z, Val(4); kwds...)
function pFqconformalrational(α::Tuple{Any, Vararg{Any, q}}, β::NTuple{q, Any}, z, m; kwds...) where q
    T1 = isempty(α) ? Any : mapreduce(typeof, promote_type, α)
    T2 = isempty(β) ? Any : mapreduce(typeof, promote_type, β)
    pFqconformalrational(T1.(α), T2.(β), z, m; kwds...)
end

function pFqconformalrational(α::Tuple{T1, T1}, β::Tuple{T2}, z::T3, ::Val{2}; kmax::Int = KMAX) where {T1, T2, T3}
    T = promote_type(T1, T2, T3)
    γ = T(β[1])
    (α, β) = T.(α)
    if abs(z) < eps(real(T))
        return one(T)
    end
    ζ = r(T(z), Val(2))
    k = 0
    wlo = zero(T)
    wmid = zero(T)
    whi = one(T)
    Slo = one(T)
    whi, wmid, wlo = (ζ/γ)*4*α*β*whi, whi, wmid
    Shi = Slo + whi
    k = 1
    while (k < kmax && errcheck(Shi, Slo, 8eps(real(T))))
        alo = T(-(k-2)*(γ-k+1))
        amid = T(-((k-1)*(3γ-4α-4β-k)+4α*β))
        ahi = T(-(k*(k-1+3γ-4α-4β)-4α*β))
        whi, wmid, wlo = (ζ/((k+1)*(k+γ)))*(ahi*whi+ζ*(amid*wmid+ζ*alo*wlo)), whi, wmid
        Shi, Slo = Shi + whi, Shi
        k += 1
    end
    k < kmax || @warn "Iteration limit reached before convergence."
    return Shi
end

function pFqconformalrational(α::Tuple{T1, T1}, β::Tuple{T2}, z::T3, ::Val{3}; kmax::Int = KMAX) where {T1, T2, T3}
    T = promote_type(T1, T2, T3)
    γ = T(β[1])
    (α, β) = T.(α)
    if abs(z) < eps(real(T))
        return one(T)
    end
    ζ = r(T(z), Val(3))
    k = 0
    wlo = zero(T)
    wmedlo = zero(T)
    wmid = zero(T)
    wmedhi = zero(T)
    whi = one(T)
    Slo = one(T)
    whi, wmedhi, wmid, wmedlo, wlo = (ζ/γ)*6*α*β*whi, whi, wmedhi, wmid, wmedlo
    Shi = Slo + whi
    k = 1
    while (k < kmax && errcheck(Shi, Slo, 8eps(real(T))))
        alo = T(2*(k-5)*(k-4) + 4*(k-4))
        amedlo = T(2*(k-4)*(k-3) - 6*γ*(k-3) + 12*(α+β)*(k-3) + 4*(k-3))
        amid = T(4*(k-3)*(k-2) - 24*γ*(k-2) + 12*(α+β)*(k-2) + 12*(k-2) + 36*α*β)
        amedhi = T(4*(k-2)*(k-1) - 36*γ*(k-1) + 36*(α+β)*(k-1) + 12*(k-1) - 72*α*β)
        ahi = T(-6*(k-1)*k - 24*γ*k + 36*(α+β)*k + 36*α*β)
        whi, wmedhi, wmid, wmedlo, wlo = (ζ/(6*(k+1)*(k+γ)))*(ahi*whi+ζ*(amedhi*wmedhi+ζ*(amid*wmid+ζ*(amedlo*wmedlo+ζ*alo*wlo)))), whi, wmedhi, wmid, wmedlo
        Shi, Slo = Shi + whi, Shi
        k += 1
    end
    k < kmax || @warn "Iteration limit reached before convergence."
    return Shi
end

function pFqconformalrational(α::Tuple{T1, T1}, β::Tuple{T2}, z::T3, ::Val{4}; kmax::Int = KMAX) where {T1, T2, T3}
    T = promote_type(T1, T2, T3)
    γ = T(β[1])
    (α, β) = T.(α)
    if abs(z) < eps(real(T))
        return one(T)
    end
    ζ = r(T(z), Val(4))
    k = 0
    wlo = zero(T)
    wmedlo = zero(T)
    wmid = zero(T)
    wmedhi = zero(T)
    whi = one(T)
    Slo = one(T)
    whi, wmedhi, wmid, wmedlo, wlo = (ζ/γ)*8*α*β*whi, whi, wmedhi, wmid, wmedlo
    Shi = Slo + whi
    k = 1
    while (k < kmax && errcheck(Shi, Slo, 8eps(real(T))))
        #alo = T(8*(k-5)*(k-4) - 8*γ*(k-4) + 16*(k-4))
        alo = (8*(k-γ) - 24)*(k-4)
        #amedlo = T(8*(k-4)*(k-3) - 40*γ*(k-3) + 64*(α+β)*(k-3) + 16*(k-3) - 64*α*β)
        amedlo = (8*k - 40*γ + 64*(α+β) - 16)*(k-3) - 64*α*β
        #amid = T(-80*γ*(k-2) + 64*(α+β)*(k-2) + 16*(k-2) + 192*α*β)
        amid = (-80*γ + 64*(α+β) + 16)*(k-2) + 192*α*β
        #amedhi = T(-80*γ*(k-1) + 64*(α+β)*(k-1) + 16*(k-1) - 192*α*β)
        amedhi = (-80*γ + 64*(α+β) + 16)*(k-1) - 192*α*β
        #ahi = T(-8*(k-1)*k - 40*γ*k + 64*(α+β)*k + 64*α*β)
        ahi = (-8*(k-1) - 40*γ + 64*(α+β))*k + 64*α*β
        whi, wmedhi, wmid, wmedlo, wlo = (ζ/(8*(k+1)*(k+γ)))*(ahi*whi+ζ*(amedhi*wmedhi+ζ*(amid*wmid+ζ*(amedlo*wmedlo+ζ*alo*wlo)))), whi, wmedhi, wmid, wmedlo
        Shi, Slo = Shi + whi, Shi
        k += 1
    end
    k < kmax || @warn "Iteration limit reached before convergence."
    return Shi
end

function pFqconformalrational(α::Tuple{T1, Vararg{T1, q}}, β::NTuple{q, T2}, z::T3, ::Val{m}; kmax::Int = KMAX) where {q, m, T1, T2, T3}
    T = promote_type(T1, T2, T3)
    if abs(z) < eps(real(T))
        return one(T)
    end
    # Transform alpha and beta
    α = Tuple(2*m .* T.(α))
    β = Tuple(2*m .* (T.(β) .- 1))

    # Defining factors L_k and R_k as operators     # L_0⋯L_q w = R_1⋯R_{q+1} w
    L = zeros(T, m+2, q)
    for j in 1:q-1
        for k in 0:m+1
            L[k+1, j] = (binomial(m, k+1) * (1 - (-1)^(k+1)) - binomial(m, k-1) * (1 - (-1)^(k-1))) * (0 - k) + ((q - j) * (m - 1) + q - j - 1) * (binomial(m, k) * (1 - (-1)^k) + binomial(m, k-1) * (1 - (-1)^(k-1))) + (-1)^k * β[j] * binomial(m, k)
        end
    end
    for k in 0:m+1
        L[k+1, q] = 2*binomial(m, 2*floor(Int, k/2) + 1) * (0 - k) + (-1)^k * β[q] * binomial(m-1, k)
    end
    ΔL = zeros(T, m+2)
    for k in 0:2:m+1
        ΔL[k+1] = 2*(binomial(m, k+1) - binomial(m, k-1))
    end
    ΔLq = zeros(T, m+2)
    for k in 0:m+1
        ΔLq[k+1] = 2*binomial(m, 2*floor(Int, k/2) + 1)
    end

    R = zeros(T, m+2, q+1)
    for j in 1:q
        for k in 0:m+1
            R[k+1, j] = (binomial(m, k+1) * (1 - (-1)^(k+1)) - binomial(m, k-1) * (1 - (-1)^(k-1))) * (0 - k) + ((q - j + 1) * (m - 1) + q - j) * (binomial(m, k) * (1 - (-1)^k) + binomial(m, k-1) * (1 - (-1)^(k-1))) + (-1)^k * α[j] * binomial(m, k)
        end
    end
    for k in 0:m+1
        R[k+1, q+1] = 2*binomial(m, 2*floor(Int, k/2) + 1) * (0 - k) + (-1)^k * α[q+1] * binomial(m-1, k)
    end
    ΔR = zeros(T, m+2)
    for k in 0:2:m+1
        ΔR[k+1] = 2*(binomial(m, k+1) - binomial(m, k-1))
    end
    ΔRqp1 = zeros(T, m+2)
    for k in 0:m+1
        ΔRqp1[k+1] = 2*binomial(m, 2*floor(Int, k/2) + 1)
    end

    Lt0 = zeros(T, m+2)
    for k in 0:m+1
        Lt0[k+1] = (binomial(m, k+1) - binomial(m, k-1)) * (0 - k) + (q*m - 1) * binomial(m+1, k)
    end
    ΔLt0 = zeros(T, m+2)
    for k in 0:m+1
        ΔLt0[k+1] = binomial(m, k+1) - binomial(m, k-1)
    end

    # Initial values for the sum
    ζ   = r(T(z), Val(m))
    Slo = zero(T)
    Shi = one(T)

    ##############################################################################################################
    # Matrices of auxiliary sequences, Z and Zt
    Z  = zeros(T, m+2, q+1)
    Zt = zeros(T, m+2, q)
    # Initialize Z (n=0)
    Z[m+2, 1] = one(T)
    for i in 0:q-1
        Z[m+2, i+2] = sum(L[k+1, q-i]*Z[m+3-(k+1), i+1] for k in 0:m+1)/ζ
    end

    # Initialize Zt (n=0)
    Zt[m+2, 1] = sum(R[k+1, q+1]*Z[m+3-(k+1), 1] for k in 0:m+1)
    for i in 1:q-1
        Zt[m+2, i+1] = sum(R[k+1, q+1-i]*Zt[m+3-(k+1), i] for k in 0:m+1)/ζ
    end

    #############   Main loop updating matrices and summing

    n = 0
    @inbounds while (n < kmax && errcheck(Shi, Slo, 8eps(real(T))))
        # Increment L
        for j in 1:q-1
            for k in 0:2:m+1
                L[k+1, j] += ΔL[k+1]
            end
        end
        for k in 0:m+1
            L[k+1, q] += ΔLq[k+1]
        end

        # Increment Z
        vn_new = (sum(R[k+1, 1]*Zt[m+3-(k+1), q] for k in 0:m+1) - ζ*sum(Lt0[k+1]*Z[m+3-(k+1), q+1] for k in 0:m+1)) / (n+1)
        for j in 1:m+1
            Z[j, q+1] = ζ*Z[j+1, q+1]
        end
        Z[m+2, q+1] = vn_new

        for i in 1:q
            zni_new = ζ*(Z[m+2, q+1-i+1] - sum(L[k+1, i]*Z[m+4-(k+1), q+1-i] for k in 1:m+1)) / (2*(n+1)*m + β[i])
            for j in 1:m+1
                Z[j, q+1-i] = ζ*Z[j+1, q+1-i]
            end
            Z[m+2, q+1-i] = zni_new
        end

        # Increment Lt0
        for k in 0:m+1
            Lt0[k+1] += ΔLt0[k+1]
        end

        # Increment R
        for j in 1:q
            for k in 0:2:m+1
                R[k+1, j] += ΔR[k+1]
            end
        end
        for k in 0:m+1
            R[k+1, q+1] += ΔRqp1[k+1]
        end

        # Increment Zt
        zt1_new = sum(R[k+1, q+1]*Z[m+3-(k+1), 1] for k in 0:m+1)
        for j in 1:m+1
            Zt[j, 1] = ζ*Zt[j+1, 1]
        end
        Zt[m+2, 1] = zt1_new

        for i in 1:q-1
            ztni_new = sum(R[k+1, q+1-i]*Zt[m+3-(k+1), i] for k in 0:m+1)/ζ
            for j in 1:m+1
                Zt[j, i+1] = ζ*Zt[j+1, i+1]
            end
            Zt[m+2, i+1] = ztni_new
        end

        Shi, Slo = Shi + Z[m+2, 1], Shi
        n += 1
    end

    return Shi
end

"""
Maclaurin series of ₚ₊₁Fₚ(α, β; z) via the generalized Euler transformation with γ = ∑β-∑α:

ₚ₊₁Fₚ(α, β; z) = (1-z)^γ w(z = 1 - ((1-ζ)/(1+ζ))^m)

"""
pFqconformalrationalgeneralizedeuler(α, β, z; kwds...) = pFqconformalrationalgeneralizedeuler(α, β, z, Val(4); kwds...)
function pFqconformalrationalgeneralizedeuler(α::Tuple{Any, Vararg{Any, q}}, β::NTuple{q, Any}, z, m; kwds...) where q
    T1 = isempty(α) ? Any : mapreduce(typeof, promote_type, α)
    T2 = isempty(β) ? Any : mapreduce(typeof, promote_type, β)
    pFqconformalrationalgeneralizedeuler(T1.(α), T2.(β), z, m; kwds...)
end


function pFqconformalrationalgeneralizedeuler(α::Tuple{T1, Vararg{T1, q}}, β::NTuple{q, T2}, z::T3, ::Val{m}; kmax::Int = KMAX) where {q, m, T1, T2, T3}
    T = promote_type(T1, T2, T3)
    if abs(z) < eps(real(T))
        return one(T)
    end
    γ = sum(β)-sum(α)
    # Transform alpha and beta
    β = Tuple(2*m .* (T.(β) .- 1))
    α = Tuple(2*m .* T.(α))
    # Defining factors L_k and R_k as operators     # L_0⋯L_q w = R_1⋯R_{q+1} w

    L = zeros(T, m+2, q)
    for j in 1:q
        for k in 0:m+1
            L[k+1, j] = (binomial(m, k+1) * (1 - (-1)^(k+1)) - binomial(m, k-1) * (1 - (-1)^(k-1))) * (0 - k)- (1 - (-1)^k)* binomial(m, k) *((q - j) * m + β[j]+2m*(γ-q+j))+ (1 - (-1)^(k-1))*binomial(m, k-1)*(q-j)*m+ β[j] * binomial(m, k)
        end
    end
    ΔL = zeros(T, m+2)
    for k in 0:2:m+1
        ΔL[k+1] = 2*(binomial(m, k+1) - binomial(m, k-1))
    end

    R = zeros(T, m+2, q+1)
    for j in 1:q+1
        for k in 0:m+1
            R[k+1, j] = (binomial(m, k+1) * (1 - (-1)^(k+1)) - binomial(m, k-1) * (1 - (-1)^(k-1))) * (0 - k) - (1 - (-1)^k)*binomial(m, k) *((q - j + 1) *m + α[j] + 2m*(γ-q+j-1)) +  (1 - (-1)^(k-1))*binomial(m, k-1)*(q-j+1)*m+ α[j] * binomial(m, k)
        end
    end
    ΔR = zeros(T, m+2)
    for k in 0:2:m+1
        ΔR[k+1] = 2*(binomial(m, k+1) - binomial(m, k-1))
    end

    # Truncated L_0
    Lt0 = zeros(T, m+3)
    for k in 0:m+2
        Lt0[k+1] = (binomial(m, k+1) - binomial(m, k-1)) * (0 - k) + q*m*binomial(m, k-1)+m*(q-2γ)*binomial(m,k)
    end
    ΔLt0 = zeros(T, m+2)
    for k in 0:m+1
        ΔLt0[k+1] = binomial(m, k+1) - binomial(m, k-1)
    end

    # Initial values for the sum
    ζ   = r(T(z), Val(m))
    Slo = zero(T)
    Shi = one(T)

    ##############################################################################################################
    # Matrices of auxiliary sequences, Z and Zt
    Z  = zeros(T, m+2, q+1)
    Zt = zeros(T, m+2, q)
    # Initialize Z (n=0)
    Z[m+2, 1] = one(T)
    for i in 0:q-1
        Z[m+2, i+2] = sum(L[k+1, q-i]*Z[m+3-(k+1), i+1] for k in 0:m+1)/ζ
    end

    # Initialize Zt (n=0)
    Zt[m+2, 1] = sum(R[k+1, q+1]*Z[m+3-(k+1), 1] for k in 0:m+1)
    for i in 1:q-1
        Zt[m+2, i+1] = sum(R[k+1, q+1-i]*Zt[m+3-(k+1), i] for k in 0:m+1)/ζ
    end

    #############   Main loop updating matrices and summing

    n = 0
    @inbounds while (n < kmax && errcheck(Shi, Slo, 8eps(real(T))))
        # Increment L
        for j in 1:q
            for k in 0:2:m+1
                L[k+1, j] += ΔL[k+1]
            end
        end

        # Increment Z
        vn_new = (sum(R[k+1, 1]*Zt[m+3-(k+1), q] for k in 0:m+1) - ζ*sum(Lt0[k+1]*Z[m+3-(k+1), q+1] for k in 0:m+1)) / (n+1)
        for j in 1:m+1
            Z[j, q+1] = ζ*Z[j+1, q+1]
        end
        Z[m+2, q+1] = vn_new

        for i in 1:q
            zni_new = ζ*(Z[m+2, q+1-i+1] - sum(L[k+1, i]*Z[m+4-(k+1), q+1-i] for k in 1:m+1)) / (2*(n+1)*m + β[i])
            for j in 1:m+1
                Z[j, q+1-i] = ζ*Z[j+1, q+1-i]
            end
            Z[m+2, q+1-i] = zni_new
        end

        # Increment Lt0
        for k in 0:m+1
            Lt0[k+1] += ΔLt0[k+1]
        end

        # Increment R
        for j in 1:q+1
            for k in 0:2:m+1
                R[k+1, j] += ΔR[k+1]
            end
        end

        # Increment Zt
        zt1_new = sum(R[k+1, q+1]*Z[m+3-(k+1), 1] for k in 0:m+1)
        for j in 1:m+1
            Zt[j, 1] = ζ*Zt[j+1, 1]
        end
        Zt[m+2, 1] = zt1_new

        for i in 1:q-1
            ztni_new = sum(R[k+1, q+1-i]*Zt[m+3-(k+1), i] for k in 0:m+1)/ζ
            for j in 1:m+1
                Zt[j, i+1] = ζ*Zt[j+1, i+1]
            end
            Zt[m+2, i+1] = ztni_new
        end

        Shi, Slo = Shi + Z[m+2, 1], Shi
        n += 1
    end

    return Shi*exp(γ*log1p(-z))
end

# HypergeometricFunctions.jl Documentation

## Introduction

[`HypergeometricFunctions.jl`](https://github.com/JuliaMath/HypergeometricFunctions.jl) provides a numerical computation of generalized hypergeometric functions. The main exported function and recommended interface is [`pFq`](@ref), but there are a few others for specialists' convenience.

```@docs
pFq
```

## Complex phase portraits

Broadly speaking, there are three classes of generalized hypergeometric functions: when $p\le q$ they are entire functions of the complex variable $z$; when $p = q+1$, they are analytic functions in the cut plane $\mathbb{C}\setminus[1,\infty)$; and, when $p > q+1$, they are analytic functions in the cut plane $\mathbb{C}\setminus[0,\infty)$.

Examples of each of these classes are illustrated over $\left\{z\in\mathbb{C} : -10<\Re z<10, -10<\Im z<10\right\}$ with [complex phase portraits](https://en.wikipedia.org/wiki/Domain_coloring), a beautiful tool in computational complex analysis.

```@example
using ComplexPhasePortrait, HypergeometricFunctions, Images
x = range(-10, stop=10, length=300)
y = range(-10, stop=10, length=300)
z = x' .+ im*y

import Logging # To avoid printing warnings
Logging.with_logger(Logging.SimpleLogger(Logging.Error)) do
    img = portrait(map(z->pFq((), (), z), z), ctype = "nist")
    save("0F0.png", img)
    img = portrait(map(z->pFq((), (1.0, ), z), z), ctype = "nist")
    save("0F1.png", img)
    img = portrait(map(z->pFq((0.5, ), (0.75, ), z), z), ctype = "nist")
    save("1F1.png", img)
    img = portrait(map(z->pFq((3.5+7.5im, ), (), z), z), ctype = "nist")
    save("1F0.png", img)
    img = portrait(map(z->pFq((1.0, 3.5+7.5im), (0.75, ), z), z), ctype = "nist")
    save("2F1.png", img)
    img = portrait(map(z->pFq((1.0, 1.5+7.5im), (), z), z), ctype = "nist")
    save("2F0.png", img)
end
nothing # hide
```

|p\q | 0 | 1 |
| :---: | :---: | :---: |
| 0 | ![₀F₀](0F0.png) | ![₀F₁](0F1.png) |
| 1 | ![₁F₀](1F0.png) | ![₁F₁](1F1.png) |
| 2 | ![₂F₀](2F0.png) | ![₂F₁](2F1.png) |

## Library

```@docs
_₁F₁
_₂F₁
_₃F₂
```

## Internals

```@docs
HypergeometricFunctions.M
HypergeometricFunctions.U
HypergeometricFunctions._₂F₁positive
HypergeometricFunctions._₂F₁general
HypergeometricFunctions._₂F₁general2
HypergeometricFunctions.pFqdrummond
HypergeometricFunctions.pFqweniger
HypergeometricFunctions.pFqcontinuedfraction
HypergeometricFunctions.pochhammer
HypergeometricFunctions.@clenshaw
HypergeometricFunctions.@lanczosratio
HypergeometricFunctions.G
HypergeometricFunctions.P
```

## Logo

```@example
using ComplexPhasePortrait, HypergeometricFunctions, Images
x = range(-1, stop=3, length=300)
y = range(-2, stop=2, length=300)
z = x' .+ im*y
img = portrait(map(z->pFq((4.25, -10.5), (7.5 + 10.0*im, ), z), z), ctype = "nist")
save("assets/logo.png", img)
nothing # hide
```
